Create wizard using tab in EJ2 JavaScript Tab control

4 Jan 202524 minutes to read

Tab items can be disabled dynamically by passing the index and boolean value to the enableTab method. You can also select an item from the tab by passing its index or HTML element to the select method.

In the following Wizard sample, each Tab is integrated with required components to complete a reservation. Each field is provided with validation for all mandatory options to proceed to the next tab. The components are added into the content using the Tab item’s template property.

    /* Initializing Tab with header and contents bind to template div for adding other components */
    tabObj = new Tab({ heightAdjustMode: 'None', height: 390, showCloseButton: false,
        selecting: tabSelected,
        items: [
            { header: { 'text': 'New Booking' }, content: '#booking' },
            { header: { 'text': 'Train List' }, content: '#selectTrain', disabled: true },
            { header: { 'text': 'Add Passenger' }, content: '#details', disabled: true },
            { header: { 'text': 'Make Payment' }, content: '#confirm', disabled: true }
        ]
    });
    tabObj.appendTo('#element');

Create the following contents for each tab in the wizard:

  1. Search tab: Created with DropDownList to select the source, destination, and type of ticket. A DatePicker is used for choosing the date of journey.
  2. Train tab: Based on the selected start and end points, a Grid is populated with a random list of available seats and train options. Initially, define the columns and row selected event for validation. After the source and destination are chosen, update the dataSource for the Grid.
  3. Passenger tab: A table with Textbox, Numeric, and DropDownList components for adding passenger name, age, gender, and preferred berth/seat. Add validation on entering passenger details to proceed.
  4. Payment tab: Calculate the ticket cost based on location, passenger count, and ticket type. Generate data for the Grid with passenger details, train number, and ticket cost summary.

You can go back to each tab using buttons available in it. Tabs are disabled to prevent navigation through tab header click actions. Once you complete the wizard, all the data is cleared, and the wizard returns to the starting tab.

ej.base.enableRipple(true);

var tabObj;
var availTrainGrid;
var ticketDetailGrid;
var endPoint;
var journeyDate;
var ticketType;
var startPoint;
var alertDlg;
var today = new Date();
var locations;
var selectedTrain;

var quota = [
    { id: '1', text: 'Business Class' },
    { id: '2', text: 'Economy Class' },
    { id: '4', text: 'Common Class' }
];
var gender = [
    { id: '1', text: 'Male' },
    { id: '2', text: 'Female' }
];
var berths = [
    { id: '1', text: 'Upper' },
    { id: '2', text: 'Lower' },
    { id: '3', text: 'Middle' },
    { id: '4', text: 'Window' },
    { id: '5', text: 'Aisle' }
];
var cities = [
    { name: 'Chicago', fare: 300 },
    { name: 'San Francisco', fare: 125 },
    { name: 'Los Angeles', fare: 175 },
    { name: 'Seattle', fare: 250 },
    { name: 'Florida', fare: 150 }
];

renderComponents();

function renderComponents() {
    /* Initialize Tab with disabled headers for the wizard */
    tabObj = new ej.navigations.Tab({
        heightAdjustMode: 'None', height: 390, showCloseButton: false,
        selecting: tabSelected,
        items: [
            { header: { 'text': 'New Booking' }, content: '#booking' },
            { header: { 'text': 'Train List' }, content: '#selectTrain', disabled: true },
            { header: { 'text': 'Add Passenger' }, content: '#details', disabled: true },
            { header: { 'text': 'Make Payment' }, content: '#confirm', disabled: true }
        ]
    });
    tabObj.appendTo('#element');
    /* Initialize the components for creating wizard */
    startPoint = new ej.dropdowns.DropDownList({
        width: '100%', dataSource: cities, floatLabelType: 'Auto', placeholder: 'From',
        fields: { text: 'name', value: 'name' }
    });
    startPoint.appendTo('#startPoint');
    endPoint = new ej.dropdowns.DropDownList({
        width: '100%', dataSource: cities, floatLabelType: 'Auto', placeholder: 'To',
        fields: { text: 'name', value: 'name' }
    });
    endPoint.appendTo('#endPoint');
    journeyDate = new ej.calendars.DatePicker({
        width: '100%', floatLabelType: 'Auto', placeholder: 'Journey Date', min: new Date(today.getTime()),
        max: new Date(today.getTime() + 60 * 24 * 60 * 60 * 1000),
        focus: function () { journeyDate.show(); }
    });
    journeyDate.appendTo('#journey_date');
    ticketType = new ej.dropdowns.DropDownList({
        dataSource: quota, placeholder: 'Ticket Type', floatLabelType: 'Auto', fields: { text: 'text', value: 'text' }
    });
    ticketType.appendTo('#ticket_type');
    alertDlg = new ej.popups.Dialog({
        header: 'Success', width: 250, isModal: true, visible: false, showCloseIcon: true,
        content: 'Your payment successfully processed', target: document.getElementById('container'), created: dlgCreated
    });
    alertDlg.appendTo('#alertDialog');
    alertDlg.hide();
    availTrainGrid = new ej.grids.Grid({
        width: "100%",
        columns: [
            { field: 'TrainNo', headerText: 'Train No', width: 120, type: 'number' },
            { field: 'Name', width: 140, headerText: 'Name' },
            { field: 'Departure', headerText: 'Departure', width: 120 },
            { field: 'Arrival', headerText: 'Arrival', width: 140 },
            { field: 'Availability', headerText: 'Availability', width: 140, type: 'number' }
        ],
        rowSelected: trainSelected
    });
    availTrainGrid.appendTo('#availableTrain');
    var age1 = new ej.inputs.NumericTextBox({ min:1, max: 100, value: 18, format: 'n0', showSpinButton: false });
    age1.appendTo('#pass_age1');
    var age2 = new ej.inputs.NumericTextBox({ min:1, max: 100, value: 18, format: 'n0', showSpinButton: false });
    age2.appendTo('#pass_age2');
    var age3 = new ej.inputs.NumericTextBox({ min:1, max: 100, value: 18, format: 'n0', showSpinButton: false });
    age3.appendTo('#pass_age3');
    var gender1 = new ej.dropdowns.DropDownList({
        dataSource: gender, text: 'Male', fields: { text: 'text', value: 'text' }
    });
    gender1.appendTo('#pass_gender1');
    var gender2 = new ej.dropdowns.DropDownList({
        dataSource: gender, text: 'Male', fields: { text: 'text', value: 'text' }
    });
    gender2.appendTo('#pass_gender2');
    var gender3 = new ej.dropdowns.DropDownList({
        dataSource: gender, text: 'Male', fields: { text: 'text', value: 'text' }
    });
    gender3.appendTo('#pass_gender3');
    var berth1 = new ej.dropdowns.DropDownList({
        dataSource: berths, placeholder: 'Optional', fields: { text: 'text', value: 'text' }
    });
    berth1.appendTo('#pass_berth1');
    var berth2 = new ej.dropdowns.DropDownList({
        dataSource: berths, placeholder: 'Optional', fields: { text: 'text', value: 'text' }
    });
    berth2.appendTo('#pass_berth2');
    var berth3 = new ej.dropdowns.DropDownList({
        dataSource: berths, placeholder: 'Optional', fields: { text: 'text', value: 'text' }
    });
    berth3.appendTo('#pass_berth3');
    ticketDetailGrid = new ej.grids.Grid({
        width: "100%",
        columns: [
            { field: 'TrainNo', headerText: 'Train No', width: 120, type: 'number' },
            { field: 'PassName', width: 140, headerText: 'Name' },
            { field: 'Gender', headerText: 'Gender', width: 120 },
            { field: 'Berth', headerText: 'Berth', width: 140 }
        ],
    });
    ticketDetailGrid.appendTo('#ticketDetailGrid');
    document.getElementById('searchNext').onclick = function (e) { tabNavigations(e); };
    document.getElementById('bookTickets').onclick = function (e) { tabNavigations(e); };
    document.getElementById('confirmTickets').onclick = function (e) { tabNavigations(e); };
    document.getElementById('makePayment').onclick = function (e) { tabNavigations(e); };
    document.getElementById('goToSearch').onclick = function (e) { tabNavigations(e); };
    document.getElementById('goBackToBook').onclick = function (e) { tabNavigations(e); };
    document.getElementById('goBackDetails').onclick = function (e) { tabNavigations(e); };
}
function tabSelected(e) {
    if (e.isSwiped) {
        e.cancel = true;
    }
}
function dlgCreated() {
    alertDlg.buttons = [{
        buttonModel: { content: 'Ok', isPrimary: true },
        click: function () {
            alertDlg.hide();
            tabObj.enableTab(0, true);
            tabObj.enableTab(1, false);
            tabObj.enableTab(2, false);
            tabObj.enableTab(3, false);
            tabObj.select(0);
        }
    }];
}
function tabNavigations(args) {
    switch (args.target.id) {
        case 'searchNext':
            /* Validate the Source, Destination, Date and Class chosen and proceed only if all the fields are selected */
            if (!ej.base.isNullOrUndefined(startPoint.value) && !ej.base.isNullOrUndefined(endPoint.value) &&
                !ej.base.isNullOrUndefined(ticketType.value) && !ej.base.isNullOrUndefined(journeyDate.value)) {
                if (!ej.base.isNullOrUndefined(startPoint.value) && startPoint.value === endPoint.value) {
                    document.getElementById('err1').innerText = '* Arrival point can\'t be same as Departure';
                }
                else {
                    tabObj.enableTab(0, false);
                    tabObj.enableTab(1, true);
                    filterTrains(args);
                    tabObj.select(1);
                    document.getElementById('err1').innerText = '';
                    document.getElementById('err2').innerText = '';
                }
            }
            else {
                document.getElementById('err1').innerText = '* Please fill all the details before proceeding';
            }
            break;
        case 'bookTickets':
            /* Based on the selected station generate Grid content to display trains available */
            if (availTrainGrid.getSelectedRecords() === undefined || availTrainGrid.getSelectedRecords().length === 0) {
                document.getElementById('err2').innerText = '* Select your convenient train';
            }
            else {
                tabObj.enableTab(2, true);
                tabObj.select(2);
                tabObj.enableTab(1, false);
                document.getElementById('err2').innerText = '';
            }
            break;
        case 'confirmTickets':
            /* Get the Passenger details and validate the fields must not be left empty */
            var name = document.getElementById('pass_name1');
            var age = document.getElementById('pass_age1');
            var gender = document.getElementById('pass_gender1');
            if (name.value === '' || age.value === '' || gender.value === '') {
                document.getElementById('err3').innerText = '* Please enter passenger details';
            }
            else {
                tabObj.enableTab(3, true);
                tabObj.select(3);
                tabObj.enableTab(2, false);
                document.getElementById('err3').innerText = '';
                finalizeDetails(args);
            }
            break;
        case 'makePayment':
            alertDlg.show();
            break;
        case 'goToSearch':
            /* Go back to change class, date or boarding places */
            selectedTrain = [];
            tabObj.enableTab(0, true);
            tabObj.select(0);
            tabObj.enableTab(1, false);
            break;
        case 'goBackToBook':
            /* Change the preferred train chosen already */
            tabObj.enableTab(1, true);
            tabObj.select(1);
            tabObj.enableTab(2, false);
            break;
        case 'goBackDetails':
            /* Update passenger detail before confirming the payment */
            tabObj.enableTab(2, true);
            tabObj.select(2);
            tabObj.enableTab(3, false);
            break;
    }
}
function filterTrains(args) {
    /* Generating trains based on source and destination chosen */
    var result = [];
    var fromCity = startPoint.text;
    var toCity = endPoint.text;
    var count = Math.floor((Math.random() * 3) + 2);
    for (var i = 0; i < count; i++) {
        var details = [];
        details.TrainNo = Math.floor((Math.random() * 20) + 19000);
        details.Name = 'Train ' + i;
        details.Departure = fromCity;
        details.Arrival = toCity;
        details.Availability = Math.floor((Math.random() * 20) + 20);
        result.push(details);
    }
    availTrainGrid.dataSource = result;
}
function finalizeDetails(args) {
    /* Get the passenger details and update table with name and other details for confirmation */
    var reserved = [];
    var passCount = 0;
    for (var i = 1; i <= 3; i++) {
        var name = document.getElementById('pass_name' + i);
        var berthSelected = document.getElementById('pass_berth' + i);
        var gender = document.getElementById('pass_gender' + i);
        if (name.value !== '') {
            var details = [];
            var berth = berthSelected.value;
            details.TrainNo = selectedTrain.TrainNo.toString();
            details.PassName = name.value;
            details.Gender = gender.value;
            details.Berth = (berth === '') ? 'Any' : berth;
            reserved.push(details);
            passCount++;
        }
        var calcFare = 0;
        for (var j = 0; j < cities; j++) {
            if (startPoint.value === cities[j].name) {
                calcFare = calcFare + cities[j].fare;
            }
            if (endPoint.value === cities[j].name) {
                calcFare = calcFare + cities[j].fare;
            }
        }
        var displayAmt = document.getElementById('amount');
        if (ticketType.value === 'Economy Class') {
            displayAmt.innerText = 'Total payable amount: $' + passCount * (300 + calcFare);
        }
        else if (ticketType.value === 'Business Class') {
            displayAmt.innerText = 'Total payable amount: $' + passCount * (500 + calcFare);
        }
        else if (ticketType.value === 'Common Class') {
            displayAmt.innerText = 'Total payable amount: $' + passCount * (150 + calcFare);
        }
    }
    ticketDetailGrid.dataSource = reserved;
}
function trainSelected(args) {
    selectedTrain = args.data;
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Tab">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" type="text/css">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
    <style>
        .e-content .e-item {
            font-size: 12px;
            margin: 10px;
        }

        #amount {
            text-align: right;
            font-size: 15px;
            padding: 15px 0;
        }

        #passenger-table th {
            text-align: center;
            font-size: 14px;
            font-weight: 400;
            border: 1px solid gainsboro;
        }

        #passenger-table td,
        #passenger-table th {
            padding: 10px;
        }

        #passenger-table td {
            border: 1px solid gainsboro;
        }

        .name-header {
            width: 200px;
        }

        .age-header {
            width: 80px;
        }

        .gender-header {
            width: 120px;
        }

        .type-header {
            width: 150px;
        }

        .btn-container {
            text-align: center;
        }

        .search-item {
            padding-right: 50px;
            padding-bottom: 20px;
        }

        .item-title {
            font-weight: 500;
            padding-top: 10px;
        }

        @media (max-width: 450px) {
            .e-sample-resize-container {
                height: 450px;
            }

            .responsive-align {
                width: 75%;
                margin: 0 auto;
            }

            .search-item {
                padding: 0 0 20px 0;
                width: 100%;
            }
        }

        #err1,
        #err2,
        #err3 {
            font-weight: bold;
            color: red;
            display: block;
            margin-top: 15px;
        }

        .wizard-title {
            font-size: 15px;
        }

        #PassengersList {
            overflow: auto;
        }

        #passenger-table {
            min-width: 500px;
            width: 100%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="alertDialog"></div>
        <div id="element"></div>
    </div>
    <div id="booking" style="display: none">
        <div class="wizard-title">Plan your journey</div>
        <div class="responsive-align">
            <div class="row">
                <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                    <input id="startPoint" class="e-input" type="text">
                </div>
                <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                    <input id="endPoint" class="e-input" type="text">
                </div>
            </div>
            <div class="row">
                <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                    <input id="journey_date" class="e-input" type="text">
                </div>
                <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                    <input id="ticket_type" class="e-input" type="text">
                </div>
            </div>
        </div>
        <div class="btn-container">
            <button id="searchNext" class="e-btn">Search Train</button>
        </div>
        <span id="err1"></span>
    </div>
    <div id="selectTrain" style="display: none">
        <div class="wizard-title">Select the train from the list </div>
        <div id="availableTrain"></div>
        <br>
        <div class="btn-container">
            <button id="goToSearch" class="e-btn">Back</button>
            <button id="bookTickets" class="e-btn">Continue</button>
        </div>
        <span id="err2"></span>
    </div>
    <div id="details" style="display: none">
        <div class="details-page wizard-title">Enter the passenger details</div>
        <div id="PassengersList">
            <table id="passenger-table">
                <colgroup>
                    <col>
                    <col>
                    <col>
                    <col>
                    <col>
                    <col>
                </colgroup>
                <thead>
                    <tr>
                        <th class="name-header">Name</th>
                        <th class="age-header">Age</th>
                        <th class="gender-header">Gender</th>
                        <th class="type-header">Berth Preference</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>
                            <input id="pass_name1" class="e-input" type="text" placeholder="Passenger Name">
                        </td>
                        <td>
                            <input id="pass_age1" class="e-input">
                        </td>
                        <td>
                            <input id="pass_gender1" type="text">
                        </td>
                        <td>
                            <input id="pass_berth1" type="text">
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <input id="pass_name2" class="e-input" type="text" placeholder="Passenger Name">
                        </td>
                        <td>
                            <input id="pass_age2" class="e-input">
                        </td>
                        <td>
                            <input id="pass_gender2" type="text">
                        </td>
                        <td>
                            <input id="pass_berth2" type="text">
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <input id="pass_name3" class="e-input" type="text" placeholder="Passenger Name">
                        </td>
                        <td>
                            <input id="pass_age3" class="e-input">
                        </td>
                        <td>
                            <input id="pass_gender3" type="text">
                        </td>
                        <td>
                            <input id="pass_berth3" type="text">
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <br>
        <div class="btn-container">
            <button id="goBackToBook" class="e-btn">Back</button>
            <button id="confirmTickets" class="e-btn">Continue</button>
        </div>
        <span id="err3"></span>
    </div>
    <div id="confirm" style="display: none">
        <div class="tab-title1 wizard-title">Confirm the details and proceed</div>
        <div id="ticketDetailGrid"></div>
        <div id="amount"></div>
        <br>
        <div class="btn-container">
            <button id="goBackDetails" class="e-btn">Back</button>
            <button id="makePayment" class="e-btn">Pay</button>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Create wizard using tab in Angular Tab component

19 Sep 202524 minutes to read

The Tab component can be configured to create step-by-step wizard interfaces by dynamically controlling tab accessibility and navigation. Tab items can be disabled dynamically by passing the index and boolean value with the enableTab method and programmatically select specific tabs using the select method by passing the index or HTML element.

Create the following contents for each tab in the wizard:

  1. Search tab:
    Created with DropDownList to select the source, destination and type of ticket. A DatePicker for choosing the date of journey.
  2. Train tab:
    Based on the selected start and end point, populated Grid with random list of available seats and train list. Initially define the columns and row selected event for validating, after the source and destination chosen update the dataSource for the Grid.
  3. Passenger tab:
    A table with Textbox, Numeric, DropDownList for adding passenger name, age, gender and preferred berth/seat. Add validation on entering passenger details to proceed.
  4. Payment tab:
    Calculate the ticket cost based on location, passenger count and ticket type. Generate data for Grid with passenger details, train number and ticket cost summary.

You can navigate back on each tab using buttons available in it and tabs are disabled to prevent navigation through tab header click actions. Once you complete the wizard all the data gets cleared and wizard returns to the starting tab.

In the following demo, designed for simple train reservation module that enables/disables tab items based on sequential validation of each Tab content.

<ejs-tab #tab id="tab_wizard" heightAdjustMode="None" height=390 showCloseButton=false (selected)="tabSelected($event)">
    <e-tabitems>
        <e-tabitem [header]='headerText[0]'>
            <ng-template #content>
                <div id='booking'>
                    <div class="wizard-title">Plan your journey</div>
                    <div class="responsive-align">
                        <div class='row'>
                            <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                                <ejs-dropdownlist #startPoint width="100%" [dataSource]='cities'
                                    [fields]='autoCompleteFields' floatLabelType='Auto' placeholder='From'>
                                </ejs-dropdownlist>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                                <ejs-dropdownlist #endPoint width="100%" [dataSource]='cities'
                                    [fields]='autoCompleteFields' floatLabelType='Auto' placeholder='To'>
                                </ejs-dropdownlist>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                                <ejs-datepicker #date width='100%' placeholder='Journey Date' floatLabelType='Auto'
                                    [min]='dateMin' [max]='dateMax' [value]='date'></ejs-datepicker>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                                <ejs-dropdownlist #quota [dataSource]='quotas' placeholder='Ticket type'
                                    floatLabelType='Auto' [fields]='fields'></ejs-dropdownlist>
                            </div>
                        </div>
                        <div class="btn-container">
                            <button id='searchNext' class='e-btn' (click)='btnClicked($event)'>Search Train</button>
                        </div>
                        <span id="err1"></span>
                    </div>
                </div>
            </ng-template>
        </e-tabitem>
        <e-tabitem [header]='headerText[1]' disabled=true>

            <ng-template #content>
                <div id='selectTrain'>
                    <div class="wizard-title">Select the train from the list </div>
                    <ejs-grid #availableTrain width="100%" (created)="availableTrainGridcreated()" (rowSelected)='trainSelected($event)'>
                        <e-columns>
                            <e-column field='TrainNo' headerText='Train No' width=120 type='number'></e-column>
                            <e-column field='Name' headerText='Name' width=140></e-column>
                            <e-column field='Departure' headerText='Departure' width=120></e-column>
                            <e-column field='Arrival' headerText='Arrival' width=140></e-column>
                            <e-column field='Availability' headerText='Availability' width=140 type='number'></e-column>
                        </e-columns>
                    </ejs-grid>
                    <br />
                    <div class="btn-container">
                        <button id="goToSearch" class='e-btn' (click)='btnClicked($event)'>Back</button>
                        <button id="bookTickets" class='e-btn' (click)='btnClicked($event)'>Continue</button>
                    </div>
                    <span id="err2"></span>
                </div>
            </ng-template>
        </e-tabitem>
        <e-tabitem [header]='headerText[2]' disabled=true>
            <ng-template #content>
                <div id='details'>
                    <div class="details-page wizard-title">Enter the passenger details</div>
                    <div id="PassengersList">
                        <table id="passenger-table">
                            <colgroup>
                                <col>
                                <col>
                                <col>
                                <col>
                                <col>
                                <col>
                            </colgroup>
                            <thead>
                                <tr>
                                    <th class="name-header">Name</th>
                                    <th class="age-header">Age</th>
                                    <th class="gender-header">Gender</th>
                                    <th class="type-header">Berth Preference</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>
                                        <input #pass_name1 class="e-input" type="text" placeholder="Passenger Name">
                                    </td>
                                    <td>
                                        <ejs-numerictextbox #pass_age1 showSpinButton=false min=1 max=100 value=18
                                            format=n0></ejs-numerictextbox>
                                    </td>
                                    <td>
                                        <ejs-dropdownlist #pass_gender1 [dataSource]='gender' text="Male"
                                            [fields]='fields'></ejs-dropdownlist>
                                    </td>
                                    <td>
                                        <ejs-dropdownlist #pass_berth1 [dataSource]='berths' placeholder="Optional"
                                            [fields]='fields'></ejs-dropdownlist>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <input #pass_name2 class="e-input" type="text" placeholder="Passenger Name">
                                    </td>
                                    <td>
                                        <ejs-numerictextbox showSpinButton=false min=1 max=100 value=18 format=n0>
                                        </ejs-numerictextbox>
                                    </td>
                                    <td>
                                        <ejs-dropdownlist #pass_gender2 [dataSource]='gender' text="Male"
                                            [fields]='fields'></ejs-dropdownlist>
                                    </td>
                                    <td>
                                        <ejs-dropdownlist #pass_berth2 [dataSource]='berths' placeholder="Optional"
                                            [fields]='fields'></ejs-dropdownlist>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <input #pass_name3 class="e-input" type="text" placeholder="Passenger Name">
                                    </td>
                                    <td>
                                        <ejs-numerictextbox showSpinButton=false min=1 max=100 value=18 format=n0>
                                        </ejs-numerictextbox>
                                    </td>
                                    <td>
                                        <ejs-dropdownlist #pass_gender3 [dataSource]='gender' text="Male"
                                            [fields]='fields'></ejs-dropdownlist>
                                    </td>
                                    <td>
                                        <ejs-dropdownlist #pass_berth3 [dataSource]='berths' placeholder="Optional"
                                            [fields]='fields'></ejs-dropdownlist>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <br />
                    <div class="btn-container">
                        <button id="goBackToBook" class='e-btn' (click)='btnClicked($event)'>Back</button>
                        <button id="confirmTickets" class='e-btn' (click)='btnClicked($event)'>Continue</button>
                    </div>
                    <span id="err3"></span>
                </div>
            </ng-template>
        </e-tabitem>
        <e-tabitem [header]='headerText[3]' disabled=true>
            <ng-template #content>
                <div id='confirm'>
                    <div class="tab-title1 wizard-title">Confirm the details and proceed</div>
                    <ejs-grid #ticketDetailGrid width="100%" (created)="ticketDetailGridcreated()">
                        <e-columns>
                            <e-column field='TrainNo' headerText='Train No' width=120 type='number'></e-column>
                            <e-column field='PassName' headerText='Name' width=140></e-column>
                            <e-column field='Gender' headerText='Gender' width=120></e-column>
                            <e-column field='Berth' headerText='Berth' width=140></e-column>
                        </e-columns>
                    </ejs-grid>
                    <br />
                    <div id="amount" #amount></div>
                    <br />
                    <div class="btn-container">
                        <button id="goBackDetails" class='e-btn' (click)='btnClicked($event)'>Back</button>
                        <button id="makePayment" class='e-btn' (click)='btnClicked($event)'>Pay</button>
                    </div>
                </div>
            </ng-template>
        </e-tabitem>
    </e-tabitems>
</ejs-tab>
<div>
    <ejs-dialog #alertDialog header='Success' width=250 isModal=true showCloseIcon=true
        content='Your payment successfully processed' [target]='dlgTarget' [buttons]='dlgButtons'
        (created)='dlgCreated()' [visible]=false></ejs-dialog>
</div>
import { NgModule } from '@angular/core'
import { FormsModule } from '@angular/forms'
import { BrowserModule } from '@angular/platform-browser'
import { GridAllModule } from '@syncfusion/ej2-angular-grids'
import { DialogAllModule } from '@syncfusion/ej2-angular-popups'
import { TabAllModule } from '@syncfusion/ej2-angular-navigations'
import { DatePickerAllModule } from '@syncfusion/ej2-angular-calendars'
import { NumericTextBoxAllModule } from '@syncfusion/ej2-angular-inputs'
import { DropDownListAllModule } from '@syncfusion/ej2-angular-dropdowns'




import { Component, ViewChild, OnInit, ViewEncapsulation, ElementRef } from '@angular/core';

import { DialogComponent } from '@syncfusion/ej2-angular-popups';
import { TabComponent, SelectEventArgs } from '@syncfusion/ej2-angular-navigations';
import { DatePickerComponent } from '@syncfusion/ej2-angular-calendars';
import { NumericTextBoxComponent } from '@syncfusion/ej2-angular-inputs';
import { GridComponent, RowSelectEventArgs } from '@syncfusion/ej2-angular-grids';
import { isNullOrUndefined as isNOU } from '@syncfusion/ej2-base';
import { DropDownListComponent } from '@syncfusion/ej2-angular-dropdowns';
/**
 * Create wizard using Tab
 */
// tslint:disable:max-line-length
@Component({
imports: [
        FormsModule,
        TabAllModule,
        
        GridAllModule,
        DialogAllModule,
        DatePickerAllModule,
        DropDownListAllModule,
        NumericTextBoxAllModule
    ],


standalone: true,
    selector: 'app-container',
    templateUrl: './app.component.html',
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    @ViewChild('tab') tab?: TabComponent;
    @ViewChild('pass_name1') input1?: ElementRef;
    @ViewChild('pass_name2') input2?: ElementRef;
    @ViewChild('pass_name3') input3?: ElementRef;
    @ViewChild('alertDialog') alertDlg?: DialogComponent;
    @ViewChild('date') journeyDate?: DatePickerComponent;
    @ViewChild('quota') ticketType?: DropDownListComponent;
    @ViewChild('endPoint') endPoint?: DropDownListComponent;
    @ViewChild('startPoint') startPoint?: DropDownListComponent;
    @ViewChild('availableTrain') availTrainGrid?: GridComponent;
    @ViewChild('pass_age1') passage1?: NumericTextBoxComponent;
    @ViewChild('ticketDetailGrid') ticketDetailGrid?: GridComponent;
    @ViewChild('pass_gender1') passgender1?: DropDownListComponent;
    @ViewChild('pass_gender2') passgender2?: DropDownListComponent;
    @ViewChild('pass_gender3') passgender3?: DropDownListComponent;
    @ViewChild('pass_berth1') passBerth1?: DropDownListComponent;
    @ViewChild('pass_berth2') passBerth2?: DropDownListComponent;
    @ViewChild('pass_berth3') passBerth3?: DropDownListComponent;

    public fields: Object = {};
    public quotas: Object[] = [];
    public gender: Object[] = [];
    public berths: Object[] = [];
    public today: Date = new Date();
    public cities?: any;
    public locations?: any;
    public headerText: Object[] = [];
    public dlgButtons: Object[] = [];
    public selectedTrain?: any;
    public autoCompleteFields: Object = {};
    public dlgTarget: HTMLElement = document.querySelector('#container') as HTMLElement;
    public dateMin?: Date;
    public dateMax?: Date;
    public result: Object[] = [];
    public reserved: Object[] = [];
    public err1: string = '';
    public err2: string = '';
    public err3: string = '';
    public displayAmt: string = '';

    public ngOnInit(): void {
        document.body.style.visibility = 'hidden';
        this.dateMin = new Date(this.today.getTime());
        this.dateMax = new Date(this.today.getTime() + 60 * 24 * 60 * 60 * 1000);
        this.headerText = [
            { 'text': 'New Booking' },
            { 'text': 'Train List' },
            { 'text': 'Add Passenger' },
            { 'text': 'Make Payment' }];

        this.quotas = [
            { id: '1', text: 'Business Class' },
            { id: '2', text: 'Economy Class' },
            { id: '4', text: 'Common Class' }
        ];

        this.gender = [
            { id: '1', text: 'Male' },
            { id: '2', text: 'Female' }
        ];

        this.berths = [
            { id: '1', text: 'Upper' },
            { id: '2', text: 'Lower' },
            { id: '3', text: 'Middle' },
            { id: '4', text: 'Window' },
            { id: '5', text: 'Aisle' }
        ];
        this.cities = [
            { name: 'Chicago', fare: 300 },
            { name: 'San Francisco', fare: 125 },
            { name: 'Los Angeles', fare: 175 },
            { name: 'Seattle', fare: 250 },
            { name: 'Florida', fare: 150 }
        ];

        this.fields = { id: 'id', text: 'text', value: 'text' };
        this.autoCompleteFields = { text: 'name', value: 'name' };

        this.dlgButtons = [{
            buttonModel: { content: 'Ok', isPrimary: true },
            click: (() => {
                (this.alertDlg as DialogComponent).hide();
                (this.tab as TabComponent).enableTab(0, true);
                (this.tab as TabComponent).enableTab(1, false);
                (this.tab as TabComponent).enableTab(2, false);
                (this.tab as TabComponent).enableTab(3, false);
                (this.tab as TabComponent).select(0);
            })
        }];
    }

    public ngAfterViewInit(): void {
        document.body.style.visibility = 'visible';
    }

    public showDate(): void {
        (this.journeyDate as DatePickerComponent).show();
    }

    public trainSelected(args: RowSelectEventArgs): void {
        this.selectedTrain = args.data;
    }

    public tabSelected(e: SelectEventArgs): void {
        if (e.isSwiped) {
            e.cancel = true;
        }
    }

    public dlgCreated(): void {
        (this.alertDlg as DialogComponent).hide();
    }

       public btnClicked(e: any): void {
        switch (e.target.id) {
            case 'searchNext':
                /* Validate the Source, Destination, Date and Class chosen and proceed only if all the fields are selected */
                if (!isNOU((this.startPoint as DropDownListComponent).value) && !isNOU((this.endPoint as DropDownListComponent).value) &&
                    !isNOU((this.ticketType as DropDownListComponent).value) && !isNOU((this.journeyDate  as DatePickerComponent ).value)) {
                    if (!isNOU((this.startPoint as DropDownListComponent).value) && (this.startPoint as DropDownListComponent).value == (this.endPoint as DropDownListComponent).value) {
                        this.err1 = '* Arrival point cannot be same as Departure';
                    } else {
                        (this.tab as TabComponent).enableTab(0, false);
                        (this.tab as TabComponent).enableTab(1, true);
                        this.filterTrains(e);
                        (this.tab as TabComponent).select(1);
                        this.err1 = '';
                        this.err2 = '';
                    }
                } else {
                    this.err1 = '* Please fill all the details before proceeding';
                }
                break;
            case 'bookTickets':
                /* Based on the selected station generate Grid content to display trains available */
                if ((this.availTrainGrid as GridComponent).getSelectedRecords() === undefined || (this.availTrainGrid as GridComponent).getSelectedRecords().length === 0) {
                    this.err2 = '* Select your convenient train';
                } else {
                    (this.tab as TabComponent).enableTab(2, true);
                    (this.tab as TabComponent).select(2);
                    (this.tab as TabComponent).enableTab(1, false);
                    this.err2 = '';
                }
                break;
            case 'confirmTickets':
                /* Get the Passenger details and validate the fields must not be left empty */
                if ((this.input1 as any).nativeElement.value === '' || isNOU((this.passgender1 as DropDownListComponent).value) || isNOU((this.passage1 as NumericTextBoxComponent).value)) {
                    this.err3 = '* Please enter passenger details';
                } else {
                    (this.tab as TabComponent).enableTab(3, true);
                    (this.tab as TabComponent).select(3);
                    (this.tab as TabComponent).enableTab(2, false);
                    this.err3 = '';
                    this.finalizeDetails(e);
                }
                break;
            case 'makePayment':
                this.alertDlg?.show();
                break;
            case 'goToSearch':
                /* Go back to change class, date or boarding places */
                this.selectedTrain = [];
                (this.tab as TabComponent).enableTab(0, true);
                (this.tab as TabComponent).select(0);
                (this.tab as TabComponent).enableTab(1, false);
                break;
            case 'goBackToBook':
                /* Change the preferred train chosen already */
                (this.tab as TabComponent).enableTab(1, true);
                (this.tab as TabComponent).select(1);
                (this.tab as TabComponent).enableTab(2, false);
                break;
            case 'goBackDetails':
                /* Update passenger detail before confirming the payment */
                (this.tab as TabComponent).enableTab(2, true);
                (this.tab as TabComponent).select(2);
                (this.tab as TabComponent).enableTab(3, false);
                break;
        }
    }
    public filterTrains(args: any): void {
        /* Generating trains based on source and destination chosen */
        let fromCity: string = <string>this.startPoint?.value;
        let toCity: string = <string>this.endPoint?.value;
        let count: number = Math.floor((Math.random() * 3) + 2);

        for (let i: number = 0; i < count; i++) {
            let details = <Details>{};
            details.TrainNo = Math.floor((Math.random() * 20) + 19000);
            details.Name = 'Train ' + i;
            details.Departure = fromCity;
            details.Arrival = toCity;
            details.Availability = Math.floor((Math.random() * 20) + 20);
            this.result.push(details);
        }
    }

    public availableTrainGridcreated(): void {
        (this.availTrainGrid as GridComponent).dataSource = this.result;
    }

    public finalizeDetails(args: any): void {
        /* Get the passenger details and update table with name and other details for confirmation */
        let passCount: any = 0;
        for (let i: number = 1; i <= 3; i++) {
            if ((this.input1 as any).nativeElement.value !== '') {
                let details = <Details>{};
                let gender: any = (i === 1) ? (this.passgender1 as DropDownListComponent).value : (i === 2) ?
                    (this.passgender2 as DropDownListComponent).value : (this.passgender3 as DropDownListComponent).value;
                let berth: any = (i === 1) ? (this.passBerth1 as DropDownListComponent).value : (i === 2) ?
                    (this.passBerth2 as DropDownListComponent).value : (this.passBerth3 as DropDownListComponent).value;
                details.TrainNo = this.selectedTrain.TrainNo.toString();
                details.PassName = (i === 1) ? (this.input1 as any).nativeElement.value : (i === 2) ?
                    (this.input2 as any).nativeElement.value : (this.input3 as any).nativeElement.value;
                details.Gender = (gender === '') ? 'Male' : gender;
                details.Berth = (berth === '') ? 'Any' : berth;
                if (details.PassName !== '') { this.reserved.push(details); }
                passCount++;
            }
            let calcFare: any = 0;
            for (let i: number = 0; i < this.cities; i++) {
                if ((this.startPoint as DropDownListComponent).value === this.cities[i].name) { calcFare = calcFare + this.cities[i].fare; }
                if ((this.endPoint as DropDownListComponent).value === this.cities[i].name) { calcFare = calcFare + this.cities[i].fare; }
            }
            if ((this.ticketType as DropDownListComponent).value === 'Economy Class') {
                this.displayAmt = "Total payable amount: $" + passCount * (300 + calcFare)
            } else if ((this.ticketType as DropDownListComponent).value === 'Business Class') {
                this.displayAmt = "Total payable amount: $" + passCount * (500 + calcFare)
            } else if ((this.ticketType as DropDownListComponent).value === 'Common Class') {
                this.displayAmt = "Total payable amount: $" + passCount * (150 + calcFare)
            }
        }
    }
    public ticketDetailGridcreated(): void {
        (this.ticketDetailGrid as GridComponent).dataSource = this.reserved;
      }
}
interface Details {
    TrainNo: number;
    Name: string;
    Departure: string;
    Arrival: string;
    Availability: number;
    PassName: string;
    Gender: any;
    Berth: string;
    SeatNo: number;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Create wizard using tab in React Tab component

29 Aug 202324 minutes to read

Tab items can be disabled dynamically by passing the index and boolean value with the enableTab method and also passing index or HTML element to select an item from the tab using select method.

Create the following contents for each tab in the wizard.

  1. Search tab:
    Created with DropDownList to select the source, destination and type of ticket. A DatePicker for choosing the date of journey.
  2. Train tab:
    Based on the selected start and end point, populated Grid with random list of available seats and train list. Initially define the columns and row selected event for validating, after the source and destination chosen update the dataSource for the Grid.
  3. Passenger tab:
    A table with Textbox, Numeric, DropDownList for adding passenger name, age, gender and preferred berth/seat. Add validation on entering passenger details to proceed.
  4. Payment tab:
    Calculate the ticket cost based on location, passenger count and ticket type. Generate data for Grid with passenger details, train number and ticket cost summary.

You can go back on each tab using buttons available in it and tabs are disabled to navigate through tab header click actions. Once you end the wizard all the data get cleared and wizard goes back to starting tab.

In the below demo, designed for simple train reservation module that enable/disable tab items based on sequential validation of each Tab content.

import * as React from "react";
import * as ReactDOM from 'react-dom';
import { useRef } from 'react';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { DatePickerComponent } from '@syncfusion/ej2-react-calendars';
import { NumericTextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { GridComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-grids';

const App = () => {
  const alertDlg = useRef(null);
  const tab = useRef(null);
  const ticketDetailGrid = useRef(null);
  const pass_gender3 = useRef(null);
  const pass_gender2 = useRef(null);
  const pass_gender1 = useRef(null);
  const pass_berth1 = useRef(null);
  const pass_berth2 = useRef(null);
  const pass_berth3 = useRef(null);
  const pass_age1 = useRef(null);
  const availTrainGrid = useRef(null);
  const ticketType = useRef(null);
  const journeyDate = useRef(null);
  const endPoint = useRef(null);
  const startPoint = useRef(null);
  const passNameFirst = useRef(null);
  const passNameSecond = useRef(null);
  const passNameThird = useRef(null);
  const err_1 = useRef(null);
  const err_2 = useRef(null);
  const err_3 = useRef(null);
  const amount = useRef(null);
  let today = new Date();
  let selectedTrain;
  let dlgTarget = document.querySelector(
    ".sb-content-tab.e-tab .e-content.sb-sample-content-area"
  );
  let dateMin = new Date(today.getTime());
  let dateMax = new Date(
    today.getTime() + 60 * 24 * 60 * 60 * 1000
  );
  let fields = { id: "id", text: "text", value: "text" };
  let autoCompleteFields = { text: "name", value: "name" };

  const headerText = [
    { text: "New Booking" },
    { text: "Train List" },
    { text: "Add Passenger" },
    { text: "Make Payment" }
  ];

  const quotas = [
    { id: "1", text: "Business Class" },
    { id: "2", text: "Economy Class" },
    { id: "4", text: "Common Class" }
  ];

  const gender = [{ id: "1", text: "Male" }, { id: "2", text: "Female" }];

  const berths = [
    { id: "1", text: "Upper" },
    { id: "2", text: "Lower" },
    { id: "3", text: "Middle" },
    { id: "4", text: "Window" },
    { id: "5", text: "Aisle" }
  ];
  const cities = [
    { name: "Chicago", fare: 300 },
    { name: "San Francisco", fare: 125 },
    { name: "Los Angeles", fare: 175 },
    { name: "Seattle", fare: 250 },
    { name: "Florida", fare: 150 }
  ];

  const dlgButtons = [
    {
      buttonModel: { content: "OK", isPrimary: true },
      // tslint:disable-next-line: no-empty
      click: () => {

        alertDlg.current.hide();
        tab.current.enableTab(0, true);
        tab.current.enableTab(1, false);
        tab.current.enableTab(2, false);
        tab.current.enableTab(3, false);
        tab.current.select(0);
      }
    }
  ];

  const dlgCreated = () => {
    alertDlg.current.hide();
  }

  const focusIn = () => {
    journeyDate.current.show()
  }

  const tabSelected = (e) => {
    if (e.isSwiped) {
      e.cancel = true;
    }
  }

  const trainSelected = (args) => {
    selectedTrain = args.data;
  }

  const btnClicked = (e) => {
    switch (e.target.id) {
      case "searchNext":
        /* Validate the Source, Destination, Date and Class chosen and proceed only if all the fields are selected */
        if (
          startPoint.current.value != null &&
          endPoint.current.value != null &&
          ticketType.current.value != null &&
          journeyDate.current.value != null
        ) {
          if (
            startPoint.current.value &&
            startPoint.current.value === endPoint.current.value
          ) {
            err_1.current.innerText =
              "* Arrival point can't be same as Departure";
          } else {
            tab.current.enableTab(0, false);
            tab.current.enableTab(1, true);
            filterTrains(e);
            tab.current.select(1);
            err_1.current.innerText = "";
            if (err_2.current) {
              err_2.current.innerText = "";
            }
          }
        } else {
          err_1.current.innerText =
            "* Please fill all the details before proceeding";
        }
        break;
      case "bookTickets":
        /* Based on the selected station generate Grid content to display trains available */
        if (
          availTrainGrid.current.getSelectedRecords() === undefined ||
          availTrainGrid.current.getSelectedRecords().length === 0
        ) {
          err_2.current.innerText =
            "* Select your convenient train";
        } else {
          tab.current.enableTab(2, true);
          tab.current.select(2);
          tab.current.enableTab(1, false);
          err_2.current.innerText = "";
        }
        break;
      case "confirmTickets":
        /* Get the Passenger details and validate the fields must not be left empty */
        const name = passNameFirst.current;
        const age = pass_age1.current.value;
        const gender = pass_gender1.current.value;
        if (name.value === "" || age === "" || gender === "") {
          err_3.current.innerText =
            "* Please enter passenger details";
        } else {
          tab.current.enableTab(3, true);
          tab.current.select(3);
          tab.current.enableTab(2, false);
          err_3.current.innerText = "";
          finalizeDetails(e);
        }
        break;
      case "makePayment":
        alertDlg.current.show();
        break;
      case "goToSearch":
        /* Go back to change class, date or boarding places */
        selectedTrain = [];
        tab.current.enableTab(0, true);
        tab.current.select(0);
        tab.current.enableTab(1, false);
        break;
      case "goBackToBook":
        /* Change the preferred train chosen already */
        tab.current.enableTab(1, true);
        tab.current.select(1);
        tab.current.enableTab(2, false);
        break;
      case "goBackDetails":
        /* Update passenger detail before confirming the payment */
        tab.current.enableTab(2, true);
        tab.current.select(2);
        tab.current.enableTab(3, false);
        break;
    }
  }

  const filterTrains = (args)=> {
    /* Generating trains based on source and destination chosen */
    const result = [];
    const fromCity = startPoint.current.value;
    const toCity = endPoint.current.value;
    const count = Math.floor(Math.random() * 3 + 2);

    for (let i = 0; i < count; i++) {
      // tslint:disable-next-line: ban-types
      const details = {};
      details.TrainNo = Math.floor(Math.random() * 20 + 19000);
      details.Name = "Train " + i;
      details.Departure = fromCity;
      details.Arrival = toCity;
      details.Availability = Math.floor(Math.random() * 20 + 20);
      result.push(details);
    }
    setTimeout(() => {
      availTrainGrid.current.dataSource = result;
      availTrainGrid.current.dataBind();
    }, 100);
  }

  const finalizeDetails = (args) => {
    /* Get the passenger details and update table with name and other details for confirmation */
    const reserved = [];
    let passCount = 0;
    const name1 = passNameFirst.current.value;
    const name2 = passNameSecond.current.value;
    const name3 = passNameThird.current.value;

    for (let i = 1; i <= 3; i++) {
      if (name1.value !== "") {
        // tslint:disable-next-line: ban-types
        const details = {};
        const gender = i === 1
          ? pass_gender1.current.value
          : i === 2
            ? pass_gender2.current.value
            : pass_gender3.current.value;
        const bert = i === 1
          ? pass_berth1.current.value
          : i === 2
            ? pass_berth2.current.value
            : pass_berth3.current.value;
        details.TrainNo = selectedTrain.TrainNo.toString();
        details.PassName =
          i === 1 ? name1.value : i === 2 ? name2.value : name3.value;
        details.Gender = gender === "" ? "Male" : gender;
        details.Berth = berth === "" ? berth : "Any";
        if (details.PassName !== "") {
          reserved.push(details);
        }
        passCount++;
      }
      let calcFare = 0;
      // tslint:disable-next-line: forin
      for (const j in cities) {
        if (startPoint.current.value === cities[j].name) {
          calcFare = calcFare + cities[j].fare;
        }
        if (endPoint.current.value === cities[j].name) {
          calcFare = calcFare + cities[j].fare;
        }
      }
      const displayAmt = amount.current;
      if (ticketType.current.value === "Economy Class" && displayAmt) {
        displayAmt.innerText =
          "Total payable amount: $" + passCount * (300 + calcFare);
      } else if (ticketType.current.value === "Business Class" && displayAmt) {
        displayAmt.innerText =
          "Total payable amount: $" + passCount * (500 + calcFare);
      } else if (ticketType.current.value === "Common Class" && displayAmt) {
        displayAmt.innerText =
          "Total payable amount: $" + passCount * (150 + calcFare);
      }
    }
    setTimeout(() => {
      (ticketDetailGrid || []).current.dataSource = reserved;
      ticketDetailGrid.current.dataBind();
    }, 100);
  }

  const content0 = () => {
    return (
      <div id="booking">
        <div className="wizard-title">Plan your journey</div>
        <div className="responsive-align">
          <div className="row">
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DropDownListComponent
                ref={
                  startPoint
                }
                width="100%"
                dataSource={cities}
                fields={autoCompleteFields}
                placeholder="From"
                floatLabelType="Auto"
              />
            </div>
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DropDownListComponent
                ref={
                  endPoint
                }
                width="100%"
                dataSource={cities}
                fields={autoCompleteFields}
                placeholder="To"
                floatLabelType="Auto"
              />
            </div>
          </div>
          <div className="row">
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DatePickerComponent
                ref={journeyDate}
                width="100%"
                placeholder="Journey Date"
                floatLabelType="Auto"
                min={dateMin}
                max={dateMax}
                focus={focusIn}
              />
            </div>
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DropDownListComponent
                ref={ticketType}
                dataSource={quotas}
                placeholder="Ticket type"
                floatLabelType="Auto"
                fields={fields}
              />
            </div>
          </div>
          <div className="btn-container">
            <button
              id="searchNext"
              className="e-btn"
              onClick={btnClicked}
            >
              Search Train
            </button>
          </div>
          <span ref={err_1} />
        </div>
      </div>
    );
  }

  const content1 = () => {
    return (
      <div id="selectTrain">
        <div className="wizard-title">Select the train from the list </div>
        <GridComponent
          ref={availTrainGrid}
          width="100%"
          rowSelected={trainSelected}
        >
          <ColumnsDirective>
            <ColumnDirective
              field="TrainNo"
              headerText="Train No"
              width={120}
              type="number"
            />
            <ColumnDirective field="Name" headerText="Name" width={140} />
            <ColumnDirective
              field="Departure"
              headerText="Departure"
              width={120}
            />
            <ColumnDirective field="Arrival" headerText="Arrival" width={140} />
            <ColumnDirective
              field="Availability"
              headerText="Availability"
              width={140}
              type="number"
            />
          </ColumnsDirective>
        </GridComponent>
        <br />
        <div className="btn-container">
          <button
            id="goToSearch"
            className="e-btn"
            onClick={btnClicked}
          >
            Back
          </button>
          <button
            id="bookTickets"
            className="e-btn"
            onClick={btnClicked}
          >
            Continue
          </button>
        </div>
        <span ref={err_2} />
      </div>
    );
  }

  const content2 = () => {
    return (
      <div id="details">
        <div className="details-page wizard-title">
          Enter the passenger details
        </div>
        <div id="PassengersList">
          <table id="passenger-table">
            <colgroup>
              <col />
              <col />
              <col />
              <col />
              <col />
              <col />
            </colgroup>
            <thead>
              <tr>
                <th className="name-header">Name</th>
                <th className="age-header">Age</th>
                <th className="gender-header">Gender</th>
                <th className="type-header">Berth Preference</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td>
                  <input
                    className="e-input"
                    ref={passNameFirst}
                    type="text"
                    placeholder="Passenger Name"
                  />
                </td>
                <td>
                  <NumericTextBoxComponent
                    ref={
                      pass_age1
                    }
                    showSpinButton={false}
                    min={1}
                    max={100}
                    value={18}
                    format="n0"
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_gender1
                    }
                    dataSource={gender}
                    text="Male"
                    fields={fields}
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_berth1
                    }
                    dataSource={berths}
                    placeholder="Optional"
                    fields={fields}
                  />
                </td>
              </tr>
              <tr>
                <td>
                  <input
                    ref={passNameSecond}
                    className="e-input"
                    type="text"
                    placeholder="Passenger Name"
                  />
                </td>
                <td>
                  <NumericTextBoxComponent
                    showSpinButton={false}
                    min={1}
                    max={100}
                    value={18}
                    format="n0"
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_gender2
                    }
                    dataSource={gender}
                    text="Male"
                    fields={fields}
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_berth2
                    }
                    dataSource={berths}
                    placeholder="Optional"
                    fields={fields}
                  />
                </td>
              </tr>
              <tr>
                <td>
                  <input
                    ref={passNameThird}
                    className="e-input"
                    type="text"
                    placeholder="Passenger Name"
                  />
                </td>
                <td>
                  <NumericTextBoxComponent
                    showSpinButton={false}
                    min={1}
                    max={100}
                    value={18}
                    format="n0"
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_gender3
                    }
                    dataSource={gender}
                    text="Male"
                    fields={fields}
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_berth3
                    }
                    dataSource={berths}
                    placeholder="Optional"
                    fields={fields}
                  />
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        <br />
        <div className="btn-container">
          <button
            id="goBackToBook"
            className="e-btn"
            onClick={btnClicked}
          >
            Back
          </button>
          <button
            id="confirmTickets"
            className="e-btn"
            onClick={btnClicked}
          >
            Continue
          </button>
        </div>
        <span ref={err_3} />
      </div>
    );
  }

  const content3 = () => {
    return (
      <div id="confirm">
        <div className="tab-title1 wizard-title">
          Confirm the details and proceed
        </div>
        <GridComponent
          ref={ticketDetailGrid}
          width="100%"
        >
          <ColumnsDirective>
            <ColumnDirective
              field="TrainNo"
              headerText="Train No"
              width={120}
              type="number"
            />
            <ColumnDirective field="PassName" headerText="Name" width={140} />
            <ColumnDirective field="Gender" headerText="Gender" width={120} />
            <ColumnDirective field="Berth" headerText="Berth" width={140} />
          </ColumnsDirective>
        </GridComponent>
        <br />
        <div ref={amount} />
        <br />
        <div className="btn-container">
          <button
            id="goBackDetails"
            className="e-btn"
            onClick={btnClicked}
          >
            Back
          </button>
          <button
            id="makePayment"
            className="e-btn"
            onClick={btnClicked}
          >
            Pay
          </button>
        </div>
      </div>
    );
  }
  return (
    <div>
      <div className="col-lg-12 control-section e-tab-section">
        <div className="e-sample-resize-container">
          <TabComponent
            id="tab-wizard"
            ref={tab}
            heightAdjustMode="None"
            height={390}
            selecting={tabSelected}
          >
            <TabItemsDirective>
              <TabItemDirective
                header={headerText[0]}
                content={content0}
              />
              <TabItemDirective
                header={headerText[1]}
                content={content1}
                disabled={true}
              />
              <TabItemDirective
                header={headerText[2]}
                content={content2}
                disabled={true}
              />
              <TabItemDirective
                header={headerText[3]}
                content={content3}
                disabled={true}
              />
            </TabItemsDirective>
          </TabComponent>
          <DialogComponent
            ref={alertDlg}
            header="Success"
            width={250}
            isModal={true}
            visible={false}
            showCloseIcon={true}
            content="Your payment successfully processed"
            target={dlgTarget}
            buttons={dlgButtons}
            created={dlgCreated}
          />
        </div>
      </div>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
import * as ReactDOM from 'react-dom';
import * as React from "react";
import { useRef } from 'react';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { DatePickerComponent } from '@syncfusion/ej2-react-calendars';
import { NumericTextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { TabComponent, TabItemDirective, TabItemsDirective, SelectEventArgs } from '@syncfusion/ej2-react-navigations';
import { GridComponent, RowSelectEventArgs, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-grids';

const App = () => {
  const alertDlg = useRef<DialogComponent>(null);
  const tab = useRef<TabComponent>(null);
  const ticketDetailGrid = useRef<GridComponent>(null);
  const pass_gender3 = useRef<DropDownListComponent>(null);
  const pass_gender2 = useRef<DropDownListComponent>(null);
  const pass_gender1 = useRef<DropDownListComponent>(null);
  const pass_berth1 = useRef<DropDownListComponent>(null);
  const pass_berth2 = useRef<DropDownListComponent>(null);
  const pass_berth3 = useRef<DropDownListComponent>(null);
  const pass_age1 = useRef<NumericTextBoxComponent>(null);
  const availTrainGrid = useRef<GridComponent>(null);
  const ticketType = useRef<DropDownListComponent>(null);
  const journeyDate = useRef<DatePickerComponent>(null);
  const endPoint = useRef<DropDownListComponent>(null);
  const startPoint = useRef<DropDownListComponent>(null);
  const passNameFirst = useRef(null);
  const passNameSecond = useRef(null);
  const passNameThird = useRef(null);
  const err_1 = useRef(null);
  const err_2 = useRef(null);
  const err_3 = useRef(null);
  const amount = useRef(null);
  let today: Date = new Date();
  let selectedTrain: any;
  let dlgTarget: HTMLElement = (document.querySelector(
    ".sb-content-tab.e-tab .e-content.sb-sample-content-area"
  ) as HTMLElement);
  let dateMin: Date = new Date(today.getTime());
  let dateMax: Date = new Date(
    today.getTime() + 60 * 24 * 60 * 60 * 1000
  );
  let fields: Object = { id: "id", text: "text", value: "text" };
  let autoCompleteFields: Object = { text: "name", value: "name" };

  const headerText: any = [
    { text: "New Booking" },
    { text: "Train List" },
    { text: "Add Passenger" },
    { text: "Make Payment" }
  ];

  const quotas: any = [
    { id: "1", text: "Business Class" },
    { id: "2", text: "Economy Class" },
    { id: "4", text: "Common Class" }
  ];

  const gender: any = [{ id: "1", text: "Male" }, { id: "2", text: "Female" }];

  const berths: any = [
    { id: "1", text: "Upper" },
    { id: "2", text: "Lower" },
    { id: "3", text: "Middle" },
    { id: "4", text: "Window" },
    { id: "5", text: "Aisle" }
  ];
  const cities: any = [
    { name: "Chicago", fare: 300 },
    { name: "San Francisco", fare: 125 },
    { name: "Los Angeles", fare: 175 },
    { name: "Seattle", fare: 250 },
    { name: "Florida", fare: 150 }
  ];

  const dlgButtons: any = [
    {
      buttonModel: { content: "OK", isPrimary: true },
      // tslint:disable-next-line: no-empty
      click: () => {

        alertDlg.current.hide();
        tab.current.enableTab(0, true);
        tab.current.enableTab(1, false);
        tab.current.enableTab(2, false);
        tab.current.enableTab(3, false);
        tab.current.select(0);
      }
    }
  ];

  const dlgCreated = (): void => {
    alertDlg.current.hide();
  }

  const focusIn = (): void => {
    journeyDate.current.show()
  }

  const tabSelected = (e: SelectEventArgs) => {
    if (e.isSwiped) {
      e.cancel = true;
    }
  }

  const trainSelected = (args: RowSelectEventArgs): void => {
    selectedTrain = args.data;
  }

  const btnClicked = (e: any): void => {
    switch (e.target.id) {
      case "searchNext":
        /* Validate the Source, Destination, Date and Class chosen and proceed only if all the fields are selected */
        if (
          startPoint.current.value != null &&
          endPoint.current.value != null &&
          ticketType.current.value != null &&
          journeyDate.current.value != null
        ) {
          if (
            startPoint.current.value &&
            startPoint.current.value === endPoint.current.value
          ) {
            err_1.current.innerText =
              "* Arrival point can't be same as Departure";
          } else {
            tab.current.enableTab(0, false);
            tab.current.enableTab(1, true);
            filterTrains(e);
            tab.current.select(1);
            err_1.current.innerText = "";
            if (err_2.current) {
              err_2.current.innerText = "";
            }
          }
        } else {
          err_1.current.innerText =
            "* Please fill all the details before proceeding";
        }
        break;
      case "bookTickets":
        /* Based on the selected station generate Grid content to display trains available */
        if (
          availTrainGrid.current.getSelectedRecords() === undefined ||
          availTrainGrid.current.getSelectedRecords().length === 0
        ) {
          err_2.current.innerText =
            "* Select your convenient train";
        } else {
          tab.current.enableTab(2, true);
          tab.current.select(2);
          tab.current.enableTab(1, false);
          err_2.current.innerText = "";
        }
        break;
      case "confirmTickets":
        /* Get the Passenger details and validate the fields must not be left empty */
        const name: any = passNameFirst.current;
        const age: any = pass_age1.current.value;
        const gender: any = pass_gender1.current.value;
        if (name.value === "" || age === "" || gender === "") {
          err_3.current.innerText =
            "* Please enter passenger details";
        } else {
          tab.current.enableTab(3, true);
          tab.current.select(3);
          tab.current.enableTab(2, false);
          err_3.current.innerText = "";
          finalizeDetails(e);
        }
        break;
      case "makePayment":
        alertDlg.current.show();
        break;
      case "goToSearch":
        /* Go back to change class, date or boarding places */
        selectedTrain = [];
        tab.current.enableTab(0, true);
        tab.current.select(0);
        tab.current.enableTab(1, false);
        break;
      case "goBackToBook":
        /* Change the preferred train chosen already */
        tab.current.enableTab(1, true);
        tab.current.select(1);
        tab.current.enableTab(2, false);
        break;
      case "goBackDetails":
        /* Update passenger detail before confirming the payment */
        tab.current.enableTab(2, true);
        tab.current.select(2);
        tab.current.enableTab(3, false);
        break;
    }
  }

  const filterTrains = (args: RowSelectEventArgs): void => {
    /* Generating trains based on source and destination chosen */
    const result: { [key: string]: Object }[] = [];
    const fromCity: string = startPoint.current.value as string;
    const toCity: string = endPoint.current.value as string;
    const count: number = Math.floor(Math.random() * 3 + 2);

    for (let i: number = 0; i < count; i++) {
      // tslint:disable-next-line: ban-types
      const details: { [key: string]: Object } = {};
      details.TrainNo = Math.floor(Math.random() * 20 + 19000);
      details.Name = "Train " + i;
      details.Departure = fromCity;
      details.Arrival = toCity;
      details.Availability = Math.floor(Math.random() * 20 + 20);
      result.push(details);
    }
    setTimeout(() => {
      availTrainGrid.current.dataSource = result;
      availTrainGrid.current.dataBind();
    }, 100);
  }

  const finalizeDetails = (args: RowSelectEventArgs): void => {
    /* Get the passenger details and update table with name and other details for confirmation */
    const reserved: { [key: string]: Object }[] = [];
    let passCount: any = 0;
    const name1: any = passNameFirst.current.value;
    const name2: any = passNameSecond.current.value;
    const name3: any = passNameThird.current.value;

    for (let i: number = 1; i <= 3; i++) {
      if (name1.value !== "") {
        // tslint:disable-next-line: ban-types
        const details: { [key: string]: Object } = {};
        const gender: string = (i === 1
          ? pass_gender1.current.value
          : i === 2
            ? pass_gender2.current.value
            : pass_gender3.current.value) as string;
        const berth: string = (i === 1
          ? pass_berth1.current.value
          : i === 2
            ? pass_berth2.current.value
            : pass_berth3.current.value) as string;
        details.TrainNo = selectedTrain.TrainNo.toString();
        details.PassName =
          i === 1 ? name1.value : i === 2 ? name2.value : name3.value;
        details.Gender = gender === "" ? "Male" : gender;
        details.Berth = berth === "" ? berth : "Any";
        if (details.PassName !== "") {
          reserved.push(details);
        }
        passCount++;
      }
      let calcFare: any = 0;
      // tslint:disable-next-line: forin
      for (const j in cities) {
        if (startPoint.current.value === cities[j].name) {
          calcFare = calcFare + cities[j].fare;
        }
        if (endPoint.current.value === cities[j].name) {
          calcFare = calcFare + cities[j].fare;
        }
      }
      const displayAmt: any = amount.current;
      if (ticketType.current.value === "Economy Class" && displayAmt) {
        displayAmt.innerText =
          "Total payable amount: $" + passCount * (300 + calcFare);
      } else if (ticketType.current.value === "Business Class" && displayAmt) {
        displayAmt.innerText =
          "Total payable amount: $" + passCount * (500 + calcFare);
      } else if (ticketType.current.value === "Common Class" && displayAmt) {
        displayAmt.innerText =
          "Total payable amount: $" + passCount * (150 + calcFare);
      }
    }
    setTimeout(() => {
      (ticketDetailGrid || []).current.dataSource = reserved;
      ticketDetailGrid.current.dataBind();
    }, 100);
  }

  const content0 = () => {
    return (
      <div id="booking">
        <div className="wizard-title">Plan your journey</div>
        <div className="responsive-align">
          <div className="row">
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DropDownListComponent
                ref={
                  startPoint
                }
                width="100%"
                dataSource={cities}
                fields={autoCompleteFields}
                placeholder="From"
                floatLabelType="Auto"
              />
            </div>
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DropDownListComponent
                ref={
                  endPoint
                }
                width="100%"
                dataSource={cities}
                fields={autoCompleteFields}
                placeholder="To"
                floatLabelType="Auto"
              />
            </div>
          </div>
          <div className="row">
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DatePickerComponent
                ref={journeyDate}
                width="100%"
                placeholder="Journey Date"
                floatLabelType="Auto"
                min={dateMin}
                max={dateMax}
                focus={focusIn}
              />
            </div>
            <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
              <DropDownListComponent
                ref={ticketType}
                dataSource={quotas}
                placeholder="Ticket type"
                floatLabelType="Auto"
                fields={fields}
              />
            </div>
          </div>
          <div className="btn-container">
            <button
              id="searchNext"
              className="e-btn"
              onClick={btnClicked}
            >
              Search Train
            </button>
          </div>
          <span ref={err_1} />
        </div>
      </div>
    );
  }

  const content1 = () => {
    return (
      <div id="selectTrain">
        <div className="wizard-title">Select the train from the list </div>
        <GridComponent
          ref={availTrainGrid}
          width="100%"
          rowSelected={trainSelected}
        >
          <ColumnsDirective>
            <ColumnDirective
              field="TrainNo"
              headerText="Train No"
              width={120}
              type="number"
            />
            <ColumnDirective field="Name" headerText="Name" width={140} />
            <ColumnDirective
              field="Departure"
              headerText="Departure"
              width={120}
            />
            <ColumnDirective field="Arrival" headerText="Arrival" width={140} />
            <ColumnDirective
              field="Availability"
              headerText="Availability"
              width={140}
              type="number"
            />
          </ColumnsDirective>
        </GridComponent>
        <br />
        <div className="btn-container">
          <button
            id="goToSearch"
            className="e-btn"
            onClick={btnClicked}
          >
            Back
          </button>
          <button
            id="bookTickets"
            className="e-btn"
            onClick={btnClicked}
          >
            Continue
          </button>
        </div>
        <span ref={err_2} />
      </div>
    );
  }

  const content2 = () => {
    return (
      <div id="details">
        <div className="details-page wizard-title">
          Enter the passenger details
        </div>
        <div id="PassengersList">
          <table id="passenger-table">
            <colgroup>
              <col />
              <col />
              <col />
              <col />
              <col />
              <col />
            </colgroup>
            <thead>
              <tr>
                <th className="name-header">Name</th>
                <th className="age-header">Age</th>
                <th className="gender-header">Gender</th>
                <th className="type-header">Berth Preference</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td>
                  <input
                    className="e-input"
                    ref={passNameFirst}
                    type="text"
                    placeholder="Passenger Name"
                  />
                </td>
                <td>
                  <NumericTextBoxComponent
                    ref={
                      pass_age1
                    }
                    showSpinButton={false}
                    min={1}
                    max={100}
                    value={18}
                    format="n0"
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_gender1
                    }
                    dataSource={gender}
                    text="Male"
                    fields={fields}
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_berth1
                    }
                    dataSource={berths}
                    placeholder="Optional"
                    fields={fields}
                  />
                </td>
              </tr>
              <tr>
                <td>
                  <input
                    ref={passNameSecond}
                    className="e-input"
                    type="text"
                    placeholder="Passenger Name"
                  />
                </td>
                <td>
                  <NumericTextBoxComponent
                    showSpinButton={false}
                    min={1}
                    max={100}
                    value={18}
                    format="n0"
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_gender2
                    }
                    dataSource={gender}
                    text="Male"
                    fields={fields}
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_berth2
                    }
                    dataSource={berths}
                    placeholder="Optional"
                    fields={fields}
                  />
                </td>
              </tr>
              <tr>
                <td>
                  <input
                    ref={passNameThird}
                    className="e-input"
                    type="text"
                    placeholder="Passenger Name"
                  />
                </td>
                <td>
                  <NumericTextBoxComponent
                    showSpinButton={false}
                    min={1}
                    max={100}
                    value={18}
                    format="n0"
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_gender3
                    }
                    dataSource={gender}
                    text="Male"
                    fields={fields}
                  />
                </td>
                <td>
                  <DropDownListComponent
                    ref={
                      pass_berth3
                    }
                    dataSource={berths}
                    placeholder="Optional"
                    fields={fields}
                  />
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        <br />
        <div className="btn-container">
          <button
            id="goBackToBook"
            className="e-btn"
            onClick={btnClicked}
          >
            Back
          </button>
          <button
            id="confirmTickets"
            className="e-btn"
            onClick={btnClicked}
          >
            Continue
          </button>
        </div>
        <span ref={err_3} />
      </div>
    );
  }

  const content3 = () => {
    return (
      <div id="confirm">
        <div className="tab-title1 wizard-title">
          Confirm the details and proceed
        </div>
        <GridComponent
          ref={ticketDetailGrid}
          width="100%"
        >
          <ColumnsDirective>
            <ColumnDirective
              field="TrainNo"
              headerText="Train No"
              width={120}
              type="number"
            />
            <ColumnDirective field="PassName" headerText="Name" width={140} />
            <ColumnDirective field="Gender" headerText="Gender" width={120} />
            <ColumnDirective field="Berth" headerText="Berth" width={140} />
          </ColumnsDirective>
        </GridComponent>
        <br />
        <div ref={amount} />
        <br />
        <div className="btn-container">
          <button
            id="goBackDetails"
            className="e-btn"
            onClick={btnClicked}
          >
            Back
          </button>
          <button
            id="makePayment"
            className="e-btn"
            onClick={btnClicked}
          >
            Pay
          </button>
        </div>
      </div>
    );
  }
  return (
    <div>
      <div className="col-lg-12 control-section e-tab-section">
        <div className="e-sample-resize-container">
          <TabComponent
            id="tab-wizard"
            ref={tab}
            heightAdjustMode="None"
            height={390}
            selecting={tabSelected}
          >
            <TabItemsDirective>
              <TabItemDirective
                header={headerText[0]}
                content={content0}
              />
              <TabItemDirective
                header={headerText[1]}
                content={content1}
                disabled={true}
              />
              <TabItemDirective
                header={headerText[2]}
                content={content2}
                disabled={true}
              />
              <TabItemDirective
                header={headerText[3]}
                content={content3}
                disabled={true}
              />
            </TabItemsDirective>
          </TabComponent>
          <DialogComponent
            ref={alertDlg}
            header="Success"
            width={250}
            isModal={true}
            visible={false}
            showCloseIcon={true}
            content="Your payment successfully processed"
            target={dlgTarget}
            buttons={dlgButtons}
            created={dlgCreated}
          />
        </div>
      </div>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tab</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='container'>
        <div id='element'>
            <div id='loader'>Loading</div>
        </div>
    </div>
</body>

</html>
#container {
    max-width: 700px;
    min-width: 520px;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.tab-control-section  .e-content .e-item {
    font-size: 12px;
    padding: 10px;
    text-align: justify;
}
.tab-control-section  .e-headertext {
    font-weight: 500;
}
.e-bigger .tab-control-section .e-tab .e-list-item {
    border-bottom: 1px solid gainsboro;
}
.tab-control-section  .e-tab .e-list-item {
    height: 63px;
    border-bottom: 1px solid gainsboro;
}
.tab-control-section  .e-tab .e-list-item:last-child {
    border-bottom: 1px solid gainsboro;
}
.e-bigger .tab-control-section  .e-tab .e-list-item {
    height: 63px;
}
.tab-control-section .template-container {
    height: 100%;
    padding-top: 7px;
}
.tab-control-section .left {
    display: inline-block;
    vertical-align: top;
}
.tab-control-section .empImg {
    height: 48px;
    width: 48px;
}
.tab-control-section .name, .role {
    line-height: normal;
}
.tab-control-section .name {
    font-weight: 500;
}
.tab-control-section .role {
    color: grey;
    font-weight: 100;
}
.tab-control-section .info-div {
    padding: 7px 0 0 15px;
}
.tab-control-section .content-title {
    height: 50px;
    display: table;
    margin: 0 auto;
}
.tab-control-section .cnt-text {
    vertical-align: middle;
    display: table-cell;
    font-size: 18px;
    font-weight: 600;
}
.tab-control-section .e-tab .e-listview .e-text {
    display: block;
    text-align: center;
}
.tab-control-section .property-panel-content {
    padding: 10px;
}
@media only screen and (min-width: 1824px) {
    .tab-control-section .col-lg-8.adaptive { /* csslint allow: adjoining-classes */
        width: 40%;
    }
    .e-bigger .tab-control-section .col-lg-8.adaptive { /* csslint allow: adjoining-classes */
        width: 45%;
    }
}
.e-content .e-item {
    font-size: 12px;
    margin: 10px;
}

#amount {
    text-align: right;
    font-size: 15px;
    padding: 15px 0;
}

#passenger-table th {
    text-align: center;
    font-size: 14px;
    font-weight: 400;
    border: 1px solid gainsboro;
}

#passenger-table td,
#passenger-table th {
    padding: 10px;
}

#passenger-table td {
    border: 1px solid gainsboro;
}

.name-header {
    width: 200px;
}

.age-header {
    width: 80px;
}

.gender-header {
    width: 120px;
}

.type-header {
    width: 150px;
}

.btn-container {
    text-align: center;
}

.search-item {
    padding-right: 50px;
    padding-bottom: 20px;
}

.item-title {
    font-weight: 500;
    padding-top: 10px;
}

@media (max-width: 450px) {
    .e-sample-resize-container {
        height: 450px;
    }
    .responsive-align {
        width: 75%;
        margin: 0 auto;
    }
    .search-item {
        padding: 0 0 20px 0;
        width: 100%;
    }
}

#err1,
#err2,
#err3 {
    font-weight: bold;
    color: red;
    display: block;
    margin-top: 15px;
}

.wizard-title {
    font-size: 15px;
}

#PassengersList {
    overflow: auto;
}
#passenger-table {
    min-width: 500px;
    width: 100%;
}

Create wizard using tab in Vue Tab component

25 May 202424 minutes to read

Tab items can be disabled dynamically by passing the index and boolean value with the enableTab method.

In the below Wizard sample, each Tab is integrated with required components to complete the reservation. Each field is provided with validation
for all mandatory option to proceed to next tabs. Using Tab item’s template property the components are added intocontent.

Create the following contents for each tab in the wizard.

  1. Search tab:
    Created with DropDownList to select the source, destination and type of ticket. A DatePicker for choosing the date of journey.
  2. Train tab:
    Based on the selected start and end point, populated Grid with random list of available seats and train list. Initially define the columns
    and row selected event for validating, after the source and destination chosen update the dataSource
    for the Grid.
  3. Passenger tab:
    A table with Textbox, Numeric, DropDownList for adding passenger name, age, gender and preferred berth/seat. Add validation on entering
    passenger details to proceed.
  4. Payment tab:
    Calculate the ticket cost based on location, passenger count and ticket type. Generate data for Grid with passenger details, train number
    and ticket cost summary.

You can go back on each tab using buttons available in it and tabs are disabled to navigate through tab header click actions. Once you end
the wizard all the data get cleared and wizard goes back to starting tab.

<template>
    <div class="col-lg-12 control-section e-tab-section">
        <div class="e-sample-resize-container" id="dialog_target">
            <div id='booking' style='display: none'>
                <div class="wizard-title">Plan your journey</div>
                <div class="responsive-align">
                    <div class='row'>
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-dropdownlist id="startPoint" width="100%" :dataSource='cities'
                                :fields='autoCompleteFields' floatLabelType='Auto'
                                placeholder='From'></ejs-dropdownlist>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-dropdownlist id="endPoint" width="100%" :dataSource='cities'
                                :fields='autoCompleteFields' floatLabelType='Auto' placeholder='To'></ejs-dropdownlist>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-datepicker id="date" width='100%' placeholder='Journey Date' floatLabelType='Auto'
                                :min='dateMin' :max='dateMax' :focus='showDate'></ejs-datepicker>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-dropdownlist id="quota" :dataSource='quotas' placeholder='Ticket type'
                                floatLabelType='Auto' :fields='fields'></ejs-dropdownlist>
                        </div>
                    </div>
                    <div class="btn-container">
                        <button id='searchNext' class='e-btn' v-on:click='btnClicked'>Search Train</button>
                    </div>
                    <span id="err1"></span>
                </div>
            </div>
            <div id='selectTrain' style='display: none'>
                <div class="wizard-title">Select the train from the list </div>
                <ejs-grid id='availableTrain' width="100%" :rowSelected='trainSelected'>
                    <e-columns>
                        <e-column field='TrainNo' headerText='Train No' width=120 type='number'></e-column>
                        <e-column field='Name' headerText='Name' width=140></e-column>
                        <e-column field='Departure' headerText='Departure' width=120></e-column>
                        <e-column field='Arrival' headerText='Arrival' width=140></e-column>
                        <e-column field='Availability' headerText='Availability' width=140 type='number'></e-column>
                    </e-columns>
                </ejs-grid>
                <br />
                <div class="btn-container">
                    <button id="goToSearch" class='e-btn' v-on:click='btnClicked'>Back</button>
                    <button id="bookTickets" class='e-btn' v-on:click='btnClicked'>Continue</button>
                </div>
                <span id="err2"></span>
            </div>
            <div id='details' style='display: none'>
                <div class="details-page wizard-title">Enter the passenger details</div>
                <div id="PassengersList">
                    <table id="passenger-table">
                        <colgroup>
                            <col>
                            <col>
                            <col>
                            <col>
                            <col>
                            <col>
                        </colgroup>
                        <thead>
                            <tr>
                                <th class="name-header">Name</th>
                                <th class="age-header">Age</th>
                                <th class="gender-header">Gender</th>
                                <th class="type-header">Berth Preference</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>
                                    <input id='pass_name1' class="e-input" type="text" placeholder="Passenger Name">
                                </td>
                                <td>
                                    <ejs-numerictextbox id='pass_age1' showSpinButton=false min=1 max=100 value=18
                                        format=n0></ejs-numerictextbox>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_gender1' :dataSource='gender' text="Male"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_berth1' :dataSource='berths' placeholder="Optional"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <input id='pass_name2' class="e-input" type="text" placeholder="Passenger Name">
                                </td>
                                <td>
                                    <ejs-numerictextbox showSpinButton=false min=1 max=100 value=18
                                        format=n0></ejs-numerictextbox>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_gender2' :dataSource='gender' text="Male"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_berth2' :dataSource='berths' placeholder="Optional"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <input id='pass_name3' class="e-input" type="text" placeholder="Passenger Name">
                                </td>
                                <td>
                                    <ejs-numerictextbox showSpinButton=false min=1 max=100 value=18
                                        format=n0></ejs-numerictextbox>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_gender3' :dataSource='gender' text="Male"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_berth3' :dataSource='berths' placeholder="Optional"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <br />
                <div class="btn-container">
                    <button id="goBackToBook" class='e-btn' v-on:click='btnClicked'>Back</button>
                    <button id="confirmTickets" class='e-btn' v-on:click='btnClicked'>Continue</button>
                </div>
                <span id="err3"></span>
            </div>
            <div id='confirm' style='display: none'>
                <div class="tab-title1 wizard-title">Confirm the details and proceed</div>
                <ejs-grid id='ticketDetailGrid' width="100%">
                    <e-columns>
                        <e-column field='TrainNo' headerText='Train No' width=120 type='number'></e-column>
                        <e-column field='PassName' headerText='Name' width=140></e-column>
                        <e-column field='Gender' headerText='Gender' width=120></e-column>
                        <e-column field='Berth' headerText='Berth' width=140></e-column>
                    </e-columns>
                </ejs-grid>
                <br />
                <div id="amount"></div>
                <br />
                <div class="btn-container">
                    <button id="goBackDetails" class='e-btn' v-on:click='btnClicked'>Back</button>
                    <button id="makePayment" class='e-btn' v-on:click='btnClicked'>Pay</button>
                </div>
            </div>
            <ejs-tab id="tab_wizard" heightAdjustMode="None" height=390 showCloseButton=false :select="tabSelected">
                <e-tabitems>
                    <e-tabitem :header='headerText0' content="#booking"></e-tabitem>
                    <e-tabitem :header='headerText1' content="#selectTrain" disabled=true></e-tabitem>
                    <e-tabitem :header='headerText2' content="#details" disabled=true></e-tabitem>
                    <e-tabitem :header='headerText3' content="#confirm" disabled=true></e-tabitem>
                </e-tabitems>
            </ejs-tab>
            <div>
                <ejs-dialog id='alertDialog' header='Success' width=250 isModal=true showCloseIcon=true
                    content='Your payment successfully processed' target='#dialog_target' :created='dlgCreated'
                    visible=false></ejs-dialog>
            </div>
        </div>
    </div>
</template>
<script setup>

import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { TabComponent as EjsTab, TabItemsDirective as ETabitems, TabItemDirective as ETabitem } from '@syncfusion/ej2-vue-navigations';
import { GridComponent as EjsGrid, ColumnsDirective as EColumns, ColumnDirective as EColumn } from '@syncfusion/ej2-vue-grids';
import { NumericTextBoxComponent as EjsNumerictextbox } from '@syncfusion/ej2-vue-inputs';
import { DialogComponent as EjsDialog } from '@syncfusion/ej2-vue-popups';
import { DatePickerComponent as EjsDatepicker } from '@syncfusion/ej2-vue-calendars';
import { DropDownListComponent as EjsDropdownlist } from "@syncfusion/ej2-vue-dropdowns";

const cities = [
    { name: 'Chicago', fare: 300 },
    { name: 'San Francisco', fare: 125 },
    { name: 'Los Angeles', fare: 175 },
    { name: 'Seattle', fare: 250 },
    { name: 'Florida', fare: 150 }
];
let selectedTrain;
const autoCompleteFields = { text: 'name', value: 'name' };
const dateMin = new Date(new Date().getTime());
const dateMax = new Date(new Date(new Date().getTime() + 60 * 24 * 60 * 60 * 1000));
const quotas = [
    { id: '1', text: 'Business Class' },
    { id: '2', text: 'Economy Class' },
    { id: '4', text: 'Common Class' }
];
const fields = { id: 'id', text: 'text', value: 'text' };
const gender = [
    { id: '1', text: 'Male' },
    { id: '2', text: 'Female' }
];
const berths = [
    { id: '1', text: 'Upper' },
    { id: '2', text: 'Lower' },
    { id: '3', text: 'Middle' },
    { id: '4', text: 'Window' },
    { id: '5', text: 'Aisle' }
];
const headerText0 = { 'text': 'New Booking' };
const headerText1 = { 'text': 'Train List' };
const headerText2 = { 'text': 'Add Passenger' };
const headerText3 = { 'text': 'Make Payment' };

const showDate = () => {
    var journeyDate = document.getElementById("date").ej2_instances[0];
    journeyDate.show();
};
const btnClicked = (args) => {
    var startPoint = document.getElementById("startPoint");
    var endPoint = document.getElementById("endPoint");
    let tabObj = document.getElementById('tab_wizard');
    switch (args.target.id) {
        case 'searchNext':
            if (!isNullOrUndefined(startPoint.value) && !isNullOrUndefined(endPoint.value) && !isNullOrUndefined(document.getElementById("quota").value) && !isNullOrUndefined(document.getElementById("date"))) {
                if (!isNullOrUndefined(startPoint.value) && startPoint.value === endPoint.value) {
                    document.getElementById('err1').innerText = '* Arrival point can\'t be same as Departure';
                } else {
                    tabObj.ej2_instances[0].enableTab(0, false);
                    tabObj.ej2_instances[0].enableTab(1, true);
                    filterTrains(args);
                    tabObj.ej2_instances[0].select(1);
                    document.getElementById('err1').innerText = '';
                    document.getElementById('err2').innerText = '';
                }
            } else {
                document.getElementById('err1').innerText = '* Please fill all the details before proceeding';
            }
            break;
        case 'bookTickets': {
            if (document.getElementById('availableTrain').ej2_instances[0].getSelectedRecords() === undefined || document.getElementById('availableTrain').ej2_instances[0].getSelectedRecords().length === 0) {
                document.getElementById('err2').innerText = '* Select your convenient train';
            } else {
                tabObj.ej2_instances[0].enableTab(2, true);
                tabObj.ej2_instances[0].select(2);
                tabObj.ej2_instances[0].enableTab(1, false);
                document.getElementById('err2').innerText = '';
            }
        }
            break;
        case 'confirmTickets': {
            let name = document.getElementById('pass_name1');
            let age = document.getElementById('pass_age1');
            let gender = document.getElementById('pass_gender1');
            if (name.value === '' || age.value === '' || gender.value === '') {
                document.getElementById('err3').innerText = '* Please enter passenger details';
            } else {
                tabObj.ej2_instances[0].enableTab(3, true);
                tabObj.ej2_instances[0].select(3);
                tabObj.ej2_instances[0].enableTab(2, false);
                document.getElementById('err3').innerText = '';
                finalizeDetails(args);
            }
        }
            break;
        case 'makePayment':
            document.getElementById('alertDialog').ej2_instances[0].show();
            break;
        case 'goToSearch':
            selectedTrain = [];
            tabObj.ej2_instances[0].enableTab(0, true);
            tabObj.ej2_instances[0].select(0);
            tabObj.ej2_instances[0].enableTab(1, false);
            break;
        case 'goBackToBook':
            tabObj.ej2_instances[0].enableTab(1, true);
            tabObj.ej2_instances[0].select(1);
            tabObj.ej2_instances[0].enableTab(2, false);
            break;
        case 'goBackDetails':
            tabObj.ej2_instances[0].enableTab(2, true);
            tabObj.ej2_instances[0].select(2);
            tabObj.ej2_instances[0].enableTab(3, false);
            break;
    }
};
const trainSelected = (args) => {
    selectedTrain = args.data;
};
const tabSelected = (args) => {
    if (args.isSwiped)
        args.cancel = true;
};
const dlgCreated = () => {
    let tabObj = document.getElementById('tab_wizard');
    let alertDlg = document.getElementById("alertDialog").ej2_instances[0];
    alertDlg.hide();
    alertDlg.content = "Your payment successflly processed";
    alertDlg.buttons = [{
        buttonModel: { content: "Ok", isPrimary: true },
        click: function () {
            document.getElementById("alertDialog").ej2_instances[0].hide();
            tabObj.ej2_instances[0].enableTab(0, true);
            tabObj.ej2_instances[0].enableTab(1, false);
            tabObj.ej2_instances[0].enableTab(2, false);
            tabObj.ej2_instances[0].enableTab(3, false);
            tabObj.ej2_instances[0].select(0);
        }
    }];
    alertDlg.dataBind();
    alertDlg.hide();
};
const filterTrains = () => {
    let result = [];
    let fromCity = document.getElementById('startPoint').text;
    let toCity = document.getElementById('endPoint').text;
    let count = Math.floor((Math.random() * 3) + 2);
    for (var i = 0; i < count; i++) {
        let details = [];
        details.TrainNo = Math.floor((Math.random() * 20) + 19000);
        details.Name = 'Train ' + i;
        details.Departure = fromCity;
        details.Arrival = toCity;
        details.Availability = Math.floor((Math.random() * 20) + 20);
        result.push(details);
    }
    document.getElementById('availableTrain').ej2_instances[0].dataSource = result;
};
const finalizeDetails = () => {
    var reserved = [];
    var passCount = 0;
    var startPoint = document.getElementById("startPoint");
    var endPoint = document.getElementById("endPoint");
    for (let i = 1; i <= 3; i++) {
        let name = document.getElementById('pass_name' + i);
        let berthSelected = document.getElementById('pass_berth' + i);
        let gender = document.getElementById('pass_gender' + i);
        if (name.value !== '') {
            let details = [];
            let berth = berthSelected.value;
            details.TrainNo = selectedTrain.TrainNo.toString();
            details.PassName = name.value;
            details.Gender = gender.value;
            details.Berth = (berth === '') ? 'Any' : berth;
            reserved.push(details);
            passCount++;
        }
        let calcFare = 0;
        for (let i = 0; i < cities; i++) {
            if (startPoint.value === cities[i].name) {
                calcFare = calcFare + cities[i].fare;
            }
            if (endPoint.value === cities[i].name) {
                calcFare = calcFare + cities[i].fare;
            }
        }
        let displayAmt = document.getElementById('amount');
        if (document.getElementById('quota').value === 'Economy Class') {
            displayAmt.innerText = "Total payable amount: $" + passCount * (300 + calcFare);
        } else if (document.getElementById("quota").value === 'Business Class') {
            displayAmt.innerText = "Total payable amount: $" + passCount * (500 + calcFare);
        } else if (document.getElementById("quota").value === 'Common Class') {
            displayAmt.innerText = "Total payable amount: $" + passCount * (150 + calcFare);
        }
    }
    document.getElementById('ticketDetailGrid').ej2_instances[0].dataSource = reserved;
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";

.e-content .e-item {
    font-size: 12px;
    margin: 10px;
}

#amount {
    text-align: right;
    font-size: 15px;
    padding: 15px 0px;
}

#passenger-table th {
    text-align: center;
    font-size: 14px;
    font-weight: 400;
    border: 1px solid gainsboro;
}

#passenger-table td,
th {
    padding: 10px;
}

#passenger-table td {
    border: 1px solid gainsboro;
}

.name-header {
    width: 200px;
}

.age-header {
    width: 80px;
}

.gender-header {
    width: 120px;
}

.type-header {
    width: 150px;
}

.btn-container {
    text-align: center;
}

.search-item {
    padding-right: 50px;
    padding-bottom: 20px;
}

.item-title {
    font-weight: 500;
    padding-top: 10px;
}

@media (max-width: 450px) {
    .e-sample-resize-container {
        height: 450px;
    }

    .responsive-align {
        width: 75%;
        margin: 0 auto;
    }

    .search-item {
        padding: 0 0 20px 0;
        width: 100%;
    }
}

#err1,
#err2,
#err3 {
    font-weight: bold;
    color: red;
    display: block;
    margin-top: 15px;
}

.wizard-title {
    font-size: 15px;
}

#PassengersList {
    overflow: auto;
}

#passenger-table {
    min-width: 500px;
    width: 100%;
}
</style>
<template>
    <div class="col-lg-12 control-section e-tab-section">
        <div class="e-sample-resize-container" id="dialog_target">
            <div id='booking' style='display: none'>
                <div class="wizard-title">Plan your journey</div>
                <div class="responsive-align">
                    <div class='row'>
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-dropdownlist id="startPoint" width="100%" :dataSource='cities'
                                :fields='autoCompleteFields' floatLabelType='Auto'
                                placeholder='From'></ejs-dropdownlist>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-dropdownlist id="endPoint" width="100%" :dataSource='cities'
                                :fields='autoCompleteFields' floatLabelType='Auto' placeholder='To'></ejs-dropdownlist>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-datepicker id="date" width='100%' placeholder='Journey Date' floatLabelType='Auto'
                                :min='dateMin' :max='dateMax' :focus='showDate'></ejs-datepicker>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6 search-item">
                            <ejs-dropdownlist id="quota" :dataSource='quotas' placeholder='Ticket type'
                                floatLabelType='Auto' :fields='fields'></ejs-dropdownlist>
                        </div>
                    </div>
                    <div class="btn-container">
                        <button id='searchNext' class='e-btn' v-on:click='btnClicked'>Search Train</button>
                    </div>
                    <span id="err1"></span>
                </div>
            </div>
            <div id='selectTrain' style='display: none'>
                <div class="wizard-title">Select the train from the list </div>
                <ejs-grid id='availableTrain' width="100%" :rowSelected='trainSelected'>
                    <e-columns>
                        <e-column field='TrainNo' headerText='Train No' width=120 type='number'></e-column>
                        <e-column field='Name' headerText='Name' width=140></e-column>
                        <e-column field='Departure' headerText='Departure' width=120></e-column>
                        <e-column field='Arrival' headerText='Arrival' width=140></e-column>
                        <e-column field='Availability' headerText='Availability' width=140 type='number'></e-column>
                    </e-columns>
                </ejs-grid>
                <br />
                <div class="btn-container">
                    <button id="goToSearch" class='e-btn' v-on:click='btnClicked'>Back</button>
                    <button id="bookTickets" class='e-btn' v-on:click='btnClicked'>Continue</button>
                </div>
                <span id="err2"></span>
            </div>
            <div id='details' style='display: none'>
                <div class="details-page wizard-title">Enter the passenger details</div>
                <div id="PassengersList">
                    <table id="passenger-table">
                        <colgroup>
                            <col>
                            <col>
                            <col>
                            <col>
                            <col>
                            <col>
                        </colgroup>
                        <thead>
                            <tr>
                                <th class="name-header">Name</th>
                                <th class="age-header">Age</th>
                                <th class="gender-header">Gender</th>
                                <th class="type-header">Berth Preference</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>
                                    <input id='pass_name1' class="e-input" type="text" placeholder="Passenger Name">
                                </td>
                                <td>
                                    <ejs-numerictextbox id='pass_age1' showSpinButton=false min=1 max=100 value=18
                                        format=n0></ejs-numerictextbox>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_gender1' :dataSource='gender' text="Male"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_berth1' :dataSource='berths' placeholder="Optional"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <input id='pass_name2' class="e-input" type="text" placeholder="Passenger Name">
                                </td>
                                <td>
                                    <ejs-numerictextbox showSpinButton=false min=1 max=100 value=18
                                        format=n0></ejs-numerictextbox>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_gender2' :dataSource='gender' text="Male"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_berth2' :dataSource='berths' placeholder="Optional"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <input id='pass_name3' class="e-input" type="text" placeholder="Passenger Name">
                                </td>
                                <td>
                                    <ejs-numerictextbox showSpinButton=false min=1 max=100 value=18
                                        format=n0></ejs-numerictextbox>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_gender3' :dataSource='gender' text="Male"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                                <td>
                                    <ejs-dropdownlist id='pass_berth3' :dataSource='berths' placeholder="Optional"
                                        :fields='fields'></ejs-dropdownlist>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <br />
                <div class="btn-container">
                    <button id="goBackToBook" class='e-btn' v-on:click='btnClicked'>Back</button>
                    <button id="confirmTickets" class='e-btn' v-on:click='btnClicked'>Continue</button>
                </div>
                <span id="err3"></span>
            </div>
            <div id='confirm' style='display: none'>
                <div class="tab-title1 wizard-title">Confirm the details and proceed</div>
                <ejs-grid id='ticketDetailGrid' width="100%">
                    <e-columns>
                        <e-column field='TrainNo' headerText='Train No' width=120 type='number'></e-column>
                        <e-column field='PassName' headerText='Name' width=140></e-column>
                        <e-column field='Gender' headerText='Gender' width=120></e-column>
                        <e-column field='Berth' headerText='Berth' width=140></e-column>
                    </e-columns>
                </ejs-grid>
                <br />
                <div id="amount"></div>
                <br />
                <div class="btn-container">
                    <button id="goBackDetails" class='e-btn' v-on:click='btnClicked'>Back</button>
                    <button id="makePayment" class='e-btn' v-on:click='btnClicked'>Pay</button>
                </div>
            </div>
            <ejs-tab id="tab_wizard" heightAdjustMode="None" height=390 showCloseButton=false :select="tabSelected">
                <e-tabitems>
                    <e-tabitem :header='headerText0' content="#booking"></e-tabitem>
                    <e-tabitem :header='headerText1' content="#selectTrain" disabled=true></e-tabitem>
                    <e-tabitem :header='headerText2' content="#details" disabled=true></e-tabitem>
                    <e-tabitem :header='headerText3' content="#confirm" disabled=true></e-tabitem>
                </e-tabitems>
            </ejs-tab>
            <div>
                <ejs-dialog id='alertDialog' header='Success' width=250 isModal=true showCloseIcon=true
                    content='Your payment successfully processed' target='#dialog_target' :created='dlgCreated'
                    visible=false></ejs-dialog>
            </div>
        </div>
    </div>
</template>

<script>

import { isNullOrUndefined } from '@syncfusion/ej2-base';
import { TabComponent, TabItemsDirective, TabItemDirective } from '@syncfusion/ej2-vue-navigations';
import { GridComponent, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-vue-grids';
import { NumericTextBoxComponent } from '@syncfusion/ej2-vue-inputs';
import { DialogComponent } from '@syncfusion/ej2-vue-popups';
import { DatePickerComponent } from '@syncfusion/ej2-vue-calendars';
import { DropDownListComponent } from "@syncfusion/ej2-vue-dropdowns";

export default {
    name: "App",
    components: {
        "ejs-dropdownlist": DropDownListComponent,
        "ejs-datepicker": DatePickerComponent,
        "ejs-grid": GridComponent,
        "e-columns": ColumnsDirective,
        "e-column": ColumnDirective,
        "ejs-numerictextbox": NumericTextBoxComponent,
        "ejs-tab": TabComponent,
        "e-tabitems": TabItemsDirective,
        "e-tabitem": TabItemDirective,
        "ejs-dialog": DialogComponent
    },
    data: function () {
        return {
            cities: [
                { name: 'Chicago', fare: 300 },
                { name: 'San Francisco', fare: 125 },
                { name: 'Los Angeles', fare: 175 },
                { name: 'Seattle', fare: 250 },
                { name: 'Florida', fare: 150 }
            ],
            autoCompleteFields: { text: 'name', value: 'name' },
            dateMin: new Date(new Date().getTime()),
            dateMax: new Date(new Date(new Date().getTime() + 60 * 24 * 60 * 60 * 1000)),
            quotas: [
                { id: '1', text: 'Business Class' },
                { id: '2', text: 'Economy Class' },
                { id: '4', text: 'Common Class' }
            ],
            fields: { id: 'id', text: 'text', value: 'text' },
            gender: [
                { id: '1', text: 'Male' },
                { id: '2', text: 'Female' }
            ],
            berths: [
                { id: '1', text: 'Upper' },
                { id: '2', text: 'Lower' },
                { id: '3', text: 'Middle' },
                { id: '4', text: 'Window' },
                { id: '5', text: 'Aisle' }
            ],
            headerText0: { 'text': 'New Booking' },
            headerText1: { 'text': 'Train List' },
            headerText2: { 'text': 'Add Passenger' },
            headerText3: { 'text': 'Make Payment' }
        }
    },
    methods: {
        showDate: function () {
            var journeyDate = document.getElementById("date").ej2_instances[0];
            journeyDate.show();
        },
        btnClicked: function (args) {
            var startPoint = document.getElementById("startPoint");
            var endPoint = document.getElementById("endPoint");
            let tabObj = document.getElementById('tab_wizard');
            switch (args.target.id) {
                case 'searchNext':
                    if (!isNullOrUndefined(startPoint.value) && !isNullOrUndefined(endPoint.value) && !isNullOrUndefined(document.getElementById("quota").value) && !isNullOrUndefined(document.getElementById("date"))) {
                        if (!isNullOrUndefined(startPoint.value) && startPoint.value === endPoint.value) {
                            document.getElementById('err1').innerText = '* Arrival point can\'t be same as Departure';
                        } else {
                            tabObj.ej2_instances[0].enableTab(0, false);
                            tabObj.ej2_instances[0].enableTab(1, true);
                            this.filterTrains(args);
                            tabObj.ej2_instances[0].select(1);
                            document.getElementById('err1').innerText = '';
                            document.getElementById('err2').innerText = '';
                        }
                    } else {
                        document.getElementById('err1').innerText = '* Please fill all the details before proceeding';
                    }
                    break;
                case 'bookTickets': {
                    if (document.getElementById('availableTrain').ej2_instances[0].getSelectedRecords() === undefined || document.getElementById('availableTrain').ej2_instances[0].getSelectedRecords().length === 0) {
                        document.getElementById('err2').innerText = '* Select your convenient train';
                    } else {
                        tabObj.ej2_instances[0].enableTab(2, true);
                        tabObj.ej2_instances[0].select(2);
                        tabObj.ej2_instances[0].enableTab(1, false);
                        document.getElementById('err2').innerText = '';
                    }
                }
                    break;
                case 'confirmTickets': {
                    let name = document.getElementById('pass_name1');
                    let age = document.getElementById('pass_age1');
                    let gender = document.getElementById('pass_gender1');
                    if (name.value === '' || age.value === '' || gender.value === '') {
                        document.getElementById('err3').innerText = '* Please enter passenger details';
                    } else {
                        tabObj.ej2_instances[0].enableTab(3, true);
                        tabObj.ej2_instances[0].select(3);
                        tabObj.ej2_instances[0].enableTab(2, false);
                        document.getElementById('err3').innerText = '';
                        this.finalizeDetails(args);
                    }
                }
                    break;
                case 'makePayment':
                    document.getElementById('alertDialog').ej2_instances[0].show();
                    break;
                case 'goToSearch':
                    this.selectedTrain = [];
                    tabObj.ej2_instances[0].enableTab(0, true);
                    tabObj.ej2_instances[0].select(0);
                    tabObj.ej2_instances[0].enableTab(1, false);
                    break;
                case 'goBackToBook':
                    tabObj.ej2_instances[0].enableTab(1, true);
                    tabObj.ej2_instances[0].select(1);
                    tabObj.ej2_instances[0].enableTab(2, false);
                    break;
                case 'goBackDetails':
                    tabObj.ej2_instances[0].enableTab(2, true);
                    tabObj.ej2_instances[0].select(2);
                    tabObj.ej2_instances[0].enableTab(3, false);
                    break;
            }
        },
        trainSelected: function (args) {
            this.selectedTrain = args.data;
        },
        tabSelected: function (args) {
            if (args.isSwiped)
                args.cancel = true;
        },
        dlgCreated: function () {
            let tabObj = document.getElementById('tab_wizard');
            let alertDlg = document.getElementById("alertDialog").ej2_instances[0];
            alertDlg.hide();
            alertDlg.content = "Your payment successflly processed";
            alertDlg.buttons = [{
                buttonModel: { content: "Ok", isPrimary: true },
                click: function () {
                    document.getElementById("alertDialog").ej2_instances[0].hide();
                    tabObj.ej2_instances[0].enableTab(0, true);
                    tabObj.ej2_instances[0].enableTab(1, false);
                    tabObj.ej2_instances[0].enableTab(2, false);
                    tabObj.ej2_instances[0].enableTab(3, false);
                    tabObj.ej2_instances[0].select(0);
                }
            }];
            alertDlg.dataBind();
            alertDlg.hide();
        },
        filterTrains: function () {
            let result = [];
            let fromCity = document.getElementById('startPoint').text;
            let toCity = document.getElementById('endPoint').text;
            let count = Math.floor((Math.random() * 3) + 2);
            for (var i = 0; i < count; i++) {
                let details = [];
                details.TrainNo = Math.floor((Math.random() * 20) + 19000);
                details.Name = 'Train ' + i;
                details.Departure = fromCity;
                details.Arrival = toCity;
                details.Availability = Math.floor((Math.random() * 20) + 20);
                result.push(details);
            }
            document.getElementById('availableTrain').ej2_instances[0].dataSource = result;
        },
        finalizeDetails: function () {
            var reserved = [];
            var passCount = 0;
            var startPoint = document.getElementById("startPoint");
            var endPoint = document.getElementById("endPoint");
            for (let i = 1; i <= 3; i++) {
                let name = document.getElementById('pass_name' + i);
                let berthSelected = document.getElementById('pass_berth' + i);
                let gender = document.getElementById('pass_gender' + i);
                if (name.value !== '') {
                    let details = [];
                    let berth = berthSelected.value;
                    details.TrainNo = this.selectedTrain.TrainNo.toString();
                    details.PassName = name.value;
                    details.Gender = gender.value;
                    details.Berth = (berth === '') ? 'Any' : berth;
                    reserved.push(details);
                    passCount++;
                }
                let calcFare = 0;
                for (let i = 0; i < this.cities; i++) {
                    if (startPoint.value === this.cities[i].name) {
                        calcFare = calcFare + this.cities[i].fare;
                    }
                    if (endPoint.value === this.cities[i].name) {
                        calcFare = calcFare + this.cities[i].fare;
                    }
                }
                let displayAmt = document.getElementById('amount');
                if (document.getElementById('quota').value === 'Economy Class') {
                    displayAmt.innerText = "Total payable amount: $" + passCount * (300 + calcFare);
                } else if (document.getElementById("quota").value === 'Business Class') {
                    displayAmt.innerText = "Total payable amount: $" + passCount * (500 + calcFare);
                } else if (document.getElementById("quota").value === 'Common Class') {
                    displayAmt.innerText = "Total payable amount: $" + passCount * (150 + calcFare);
                }
            }
            document.getElementById('ticketDetailGrid').ej2_instances[0].dataSource = reserved;
        }
    }
}

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";

.e-content .e-item {
    font-size: 12px;
    margin: 10px;
}

#amount {
    text-align: right;
    font-size: 15px;
    padding: 15px 0px;
}

#passenger-table th {
    text-align: center;
    font-size: 14px;
    font-weight: 400;
    border: 1px solid gainsboro;
}

#passenger-table td,
th {
    padding: 10px;
}

#passenger-table td {
    border: 1px solid gainsboro;
}

.name-header {
    width: 200px;
}

.age-header {
    width: 80px;
}

.gender-header {
    width: 120px;
}

.type-header {
    width: 150px;
}

.btn-container {
    text-align: center;
}

.search-item {
    padding-right: 50px;
    padding-bottom: 20px;
}

.item-title {
    font-weight: 500;
    padding-top: 10px;
}

@media (max-width: 450px) {
    .e-sample-resize-container {
        height: 450px;
    }

    .responsive-align {
        width: 75%;
        margin: 0 auto;
    }

    .search-item {
        padding: 0 0 20px 0;
        width: 100%;
    }
}

#err1,
#err2,
#err3 {
    font-weight: bold;
    color: red;
    display: block;
    margin-top: 15px;
}

.wizard-title {
    font-size: 15px;
}

#PassengersList {
    overflow: auto;
}

#passenger-table {
    min-width: 500px;
    width: 100%;
}
</style>